4.52v

1. Widget will remain opened/closed across pages domain/subdomains. Widget will load chat instantly if chat is started on another tab of the same page.
2. If NodeJS is used and chat is started on subdomain it will continue on all subdomain of the main domain.
3. On page reload widget will avoid flickering while loading main widget components.
4. Inline form will have a check to avoid it being submitted after chat was closed.
5. Widget sounds settings will remain the same across the domain/subdomain navigation
6. It's possible to mask sensitive information before it sending to Rest API endpoint. https://doc.livehelperchat.com/docs/bot/rest-api#magic-prefixes-for-replaceable-variables
7. Bot log will log much more events and is usefull for bot debugging. It's activated in department edit. Log will appear in audit log.
8. Markdown standard link support for better ChatGPT support.
9. Rest API debug enhancement options. https://doc.livehelperchat.com/docs/bot/rest-api#audit-log
10. If initial intro message was long, we did not scrolled to the bottom as we should.
11. If `'lhaudit','see_audit_system'` permission was not set, operator will not see Rest API messages logged in the chat.
12. Now it's possible to block third party chat from incoming webhooks.
13. Sub URL has magic prefix `urlencode_` to encode elements in the query. https://doc.livehelperchat.com/docs/bot/rest-api#sub-url
14. Option to disable mail ticket closed for some of the mailbox even if customer e-mail matches few of the tickets.
15. Option to choose to show bot profile in widget theme.
16. Maintenance mode improvements.
17. Stream as HTML support for Rest API calls.
18. Simple search for personal canned messages.
19. In triple quotes sometimes code was parsed as a code. We should not parse anything in triple quotes.
20. Improvements in explanations for e-mail messages.
21. In department list you can search by department alias.
22. Now it's possible to define multiple work periods in the single day.
23. Updated to React 18 widget.
24. Brand new text editor for the operators. Can be activated in the dashboard settings.

No database update this time.


4.51v

1. Now you can remove selected message completely.
2. Preparation for further works on custom online periods per department.
3. Online/Offline peridios for operator will be tracked more precisely.
4. Switch from || to OR syntax for SQL queries.
5. Hours format for work hours switched to 23:59 as max value for end period.


execute doc/update_db/update_321.sql for update

4.50v

1. You can put quickly chat into maintenance mode.
2. Improvements how online status is checked once there is no passed department.

execute doc/update_db/update_320.sql for update

4.49v

1. You can set custom department strictly offline.

execute doc/update_db/update_319.sql for update

4.48v

1. Mobile notifications will work now for Mobile App. Although correct windows may not open.
2. Chat GPT Flow support In Rest API section. Polling support.
3. Survey page will show only collected items for departments agent is assigned to.
4. Replaceable variables will be supported also in proactive chat invitations.
5. Message edit action support for web UI if visitor edit's it's message.

execute doc/update_db/update_318.sql for update

4.47v

1. Blinking title fixes with one page applications.
2. Option to remember phone, email for the next time visitor starts a chats
3. Chat delete event was missing on chat deletion from list.
4. Compatibility with new Facebook Extension including WhatsApp, Instagram, Messenger support.
5. Statistic chart will not include 17 as default work hour.
6. SSO extension compatibility 

execute doc/update_db/update_317.sql for update

4.46v

1. More options to parse incoming request for incoming webhooks
2. Auto responder now can be disabled.
3. Sensitive information display fixes if operator does not have permission to view an e-mail.
4. Preparation for Facebook Messenger extension new version.
5. Check conditions bot response was working incorrectly in some situations.
6. Mail search will lowercase e-mails and remove dots.

execute doc/update_db/update_316.sql for update

4.45v

1. E-Mail conversations search will now use `from_address_clean` attribute which is a new attribute without dot's in the name.
2. If whisper message is send it won't influence arrows in the dashboard widget or auto responder flow.
3. Chat print window was improved.

There is few queries to populate that field in the update file.
execute doc/update_db/update_315.sql for update

You can also just run this file after you have updated official version. You do not have to run this script if you are not using mail module.

`php cron.php -s site_admin -c cron/update/update_445`

4.44v

1. You can enter IP or IP range in back office which is not allowed to be blocked.
2. Widget theme translations will override only default language and use default translation for other languages.
3. 8.* PHP fixes.
4. Transaction will be used for online vars update to avoid inconsistency.
5. If your VPS has multiple IP you can configure which one should be used fot SMTP sending. DigitalOcean scenario with Reserved IP.
6. Submenu will be hidden for main left menu while rendering back office page.
7. Widget resize improvements.
8. Auto assignment consistency improvements.
9. Views will use dynamic date range and not fixed.
10. Various other fixes/improvements.

execute doc/update_db/update_314.sql for update

4.43v

1. Embedded forms in chat now can completely hide form content on success submission.
2. If embeded form is submitted it's content will be hidden instantly to improve UI

execute doc/update_db/update_313.sql for update

4.42v

1. Composer dependencies bumped to 8.2 PHP version. In order to run on older PHP version reinstall composer dependencies.
2. Additional chat variables can extract JWT token custom field and store it as a chat variable etc.
3. Widget themes now has option to set reaction bubble and icons colors separately.
4. MacOS was not rendering online visitors list.
5. If two departments has same alias. Alias with language prefix fre-my-alias will have higher priority than my-alias. That way you fan forward other language chats to specific departments.

execute doc/update_db/update_312.sql for update


4.41v

1. Departments now have individual `Ignore operator status` settings.

execute doc/update_db/update_311.sql for update

4.40v

1. Visitors statistic charts are now generated much faster using database implementation.
2. Iframe bot response type now supports forms.
3. If same department alias is used for multiple departments, online status check will use department sort priority.
4. Canned messages hashtag list will indicate we hit limit and not all results are rendered.
5. Page based invitations now can be combined with general ones. https://doc.livehelperchat.com/docs/proactive#how-to-setup-url-based-invitations
6. Offline form submit will use very first passed department to match online chat logic.
7. Operators will be to test notifications from their account.
8. Various other fixes.

execute doc/update_db/update_310.sql for update

4.39v

1. https://github.com/LiveHelperChat/electron/releases Electron app was updated to 124 chrome version.
2. If Rest API was used as "raw_{some_var}" and variable had a quote at the end, it was incorrectly encoded resulting in broken JSON.
3. Added support for large numbers of chats/e-mails export from ElasticSearch extension.
4. Fixed some of the icons in dashboard widgets after migration to svelte.
5. Edge case fixes for the widget and ignoring some of the errors because of to old browsers version.
6. Fixes for DeppL language translation services.
7. Keyword in ElasticSearch always will be a GET parameter to avoid hitting apache path length limit.
8. Handle missing file after e-mail import so it's correctly downloaded viewing e-mail from back office.
9. Logging will handle incorrect UTF characters.
10. Fix for https://github.com/LiveHelperChat/livehelperchat/issues/2003
11. Deleting chats from list had a limit. It should not have and delete all selected chats.
12. Online visitors attribute filter sometimes was lost.
13. Online operators tab was migrated to Svelte also.
14. Mobile app was not working because of incorrect expression in SQL while two tables are used under JOIN condition.
15. Ignore invalid JSON characters in e-mail module.

There is no database update this time.

4.38v

1. Bot commands can can be sorted by position
2. Preparation for a new flow for mail messages import.

execute doc/update_db/update_309.sql for update

4.37v

1. Options to execute bot commands from chat UI directly without typing them.
2. Online operators widget has a lot of new functions and indicators.
3. Messages in back office has indicator were they sent by auto responder.
4. Material symbols icons were updated.
5. More gracefull errors handling in transfer workflow.

execute doc/update_db/update_308.sql for update

4.36v

1. Colored subject support for mail modules
2. Views were missing subjects and some lists colors
3. Online status check now has option to cache it's status for one minute.
4. Fixed bold style in some places which were using old bootstrap bold text class.
5. Add icon bot response type now has possibility to change nick bold style and color.
6. Offline e-mail template now can strictly send all e-mails to one recipient and ignore department e-mail.

execute doc/update_db/update_307.sql for update

4.35v

1. Audit log was recoding errors in incorrect time zone.
2. Subjects now can be pinned and be shown on Pending/Bot/Active/My Chats widgets chats
3. Incoming webhook fixes for base64decode files
4. Department stats were missing if department group was not used.
5. Audit log now has an export function.
6. Audit log time filter was fixed.

execute doc/update_db/update_306.sql for update

4.34v

1. Notification for assigned pending chat was missing.
2. Continuous webhooks for mails finished.
3. Check for CSV file encoding during import.
4. Option to filter for agents statistic who were online.
5. Country flag icon always will be the first icon in the widget.

execute doc/update_db/update_305.sql for update

4.33v

1. Delete and Delete and archive options has option to ignore imap delete independently.
2. Bugfix for "impossible to edit previous message".
3. Preparation for continuous mails webhook
3. [code] ``` long code ``` or ` inline code ` support
4. `chat.webhook_incoming_chat_before_save` event before saving intial chat.
5. Various Svelte improvements for `cbscheduler` extension.

execute doc/update_db/update_304.sql for update

4.32v

1. Background delete workflow if you have a lot of mails to delete.
2. Active schedule for department was not working after migration to Svelte.
3. Mail delete scheduler. Usefull in case you want to delete hundreds of thousands of emails.
4. Widget images now has a size defined which avoids flickering while images are loading in the widget or in Live Helper Chat back office.
5. Telegram extension now supports commands from operator who is using telegram as a support client.
6. There is new permission to allow operator edit only last his message or all his messages per chat. By default he will be able to edit only last his message.
7. Proactive invitation now has URL filter and activity period.
8. Search in some pages were broken if # was used as search argument.
9. Now you can set Time Zone for the database. Usefull in case you want to set everywhere same time zone to avoid any issues.
10. Mailbox has more options for delete policy. Move mail or purge completely. Also delete can be activated for archive process.

execute doc/update_db/update_303.sql for update

4.31v

1. Optimisation online visitors widget.
2. Svelte fixes for Nan being presented in departments load widget.
3. Various small fixes.

execute doc/update_db/update_302.sql for update

4.30v

Brand new mail module and svelte based dashboard.

execute doc/update_db/update_301.sql for update

4.29v

1. New chat attribute `First response time (agent)` attribute `frt`.
2. New chat attribute `Max response time (agent)`attribute `mart`.
3. New chat attribute `Average response time (agent)` attribute `aart`.
4. All new attributes is represented in chat statistic/search/chat right column.
5. Agents can have personal theme by having `'lhabstract','use'` and `'lhtheme','personaltheme'` permissions.
6. To update present chats with new attributes values you can run `php cron.php -s site_admin -c cron/util/update_times -p <chat_id_to_update_from>`

execute doc/update_db/update_300.sql for update

4.28v

1. Widget theme now allows to set message time visibility options for operator and visitor. [Above message or below messages]
2. Now there is option to have a custom HTML below page widget `Custom html after widget content`
3. Full height option support in the widget.
4. Various other small changes...

execute doc/update_db/update_299.sql for update

4.27v

1. Avoid flicker once chat is started for a new widget.
2. Option to show clicked button name instantly in messages area. `Widget container -> Print button as a message as soon visitor clicks a button.`
3. Incoming webhook `chat_external_id` field is now 100 chars instead of 50
4. We will show visitor message as soon he clicks send.
5. 8.2 php support, if you notice some errors let me know.
6. Voice messages max length option from files configuration was ignored.
7. Chrome 116v workaround for chrome bug.  Changes I did https://github.com/LiveHelperChat/livehelperchat/commit/b3649c5e936d4be08d1e004d8537ed47cd029aba chrome bug report. https://bugs.chromium.org/p/chromium/issues/detail?id=1473754 it should be fixed in 117v chrome release.
8. Audit configuration window has a system information details
9. Autoresponder cronjob cache issues fixes.
10. Option to use visitor TZ or system TZ always for messages rendering if they have time based messages. Can be activated in widget themes.
11. Geo detection test window.
12. More variables for Rest API

execute doc/update_db/update_298.sql for update

4.26v

1. Message delivery status indication.
2. Old chats will show messages as undelivered. Or you can execute query from update file.
3. This time it's recommended to run queries from `update_298.sql` to avoid database locks. Make sure you know what you are doing.

execute doc/update_db/update_298.sql for update

4.25v

1. Participant concept in chat's statistic.
2. Brand concept in chat handling workflows.

execute doc/update_db/update_297.sql for update

4.24v

1. In rare cases, if processing incoming webhook took a long time and a second request was sent one after another two chats were created. Transaction locking were added.
2. Option to log non-parsed messages and log all requests. Useful for debugging while debug output is disabled. E.g in production env.

execute doc/update_db/update_296.sql for update

4.23v

1. Option to hide sensitive information from operators if they don't have permission to access 'lhchat','see_sensitive_information'

execute doc/update_db/update_295.sql for update

4.22v

1. Department assignment now have new UI.
2. Department assignment operator can have custom nick per department.

execute doc/update_db/update_294.sql for update

4.21v

1. Chat list now can show custom columns also.
2. Various other changes

execute doc/update_db/update_293.sql for update

4.20v

1. Options to have expire-able canned message with auto delete.
2. Option to have one time period canned message without expire date.

execute doc/update_db/update_292.sql for update

4.19v

1. Inline survey support. You can send inline survey from bot.
1.1 Limitations: `stars` at the moment are not supported. Will be added in feature releases.
2. Auto responder active period options.

execute doc/update_db/update_291.sql for update

4.18v

1. Auto responder can be assigned to multiple departments at once.
2. Replaceable variables can have active period per replace.
3. Respect operator permission for calls module before showing call icon in the widget.
4. Fast typing fixes for canned messages.
5. Dark mode fixes after migration to bootstrap 5.
6. Widgets will show how long it took to fetch specific widget information.

execute doc/update_db/update_290.sql for update

4.17v

1. Advanced chat auto assignment options.
2. Separate permissions for operators to crate a views.
3. Slow request logging to back office.
4. Modal window improvements for department online operators statistic.
5. Further migration related to bootstrap 5 migration.
6. And various other changes/fixes.

execute doc/update_db/update_289.sql for update

4.16v

1. Theme attribute will be saved directly in the chat table. So we can use search from now.
2. You now can pass more than one theme at once. Theme will be chosen randomly from passed one. You can fixate period from widget theme itself how long same theme would be applied. If one theme is passed it will be always used.
3. Fixed bug once permission `'lhchat', 'allowtransfertoanyuser'` was removed, operator still saw operators from other departments.
4. `'lhdepartment', 'see_all'` permission now can have limitation like 	{"group":[1,2,3,9,10],"department":[45,46]}
5. `'lhchat','allowtransfertoanyuser'` permission now can have limitation like 	{"group":[1,2,3,9,10]}

execute doc/update_db/update_288.sql for update

4.15v

1. Incoming webhooks now can be represented in the chat list with an icon.

execute doc/update_db/update_287.sql for update

4.14v

* Proactive invitation now have user initiated conversions https://doc.livehelperchat.com/docs/proactive#conversion

execute doc/update_db/update_286.sql for update

4.13v

* Proactive invitations can have child invitation which works as A/B testing workflow.
    * Once you define a parent invitation. Present invitation is considered as child invitation.
    * Only main display attributes are taken as variation.
    * Parent invitation statistic window will show child invitation performance.
* Bot pause trigger. https://github.com/LiveHelperChat/livehelperchat/pull/1797
* Proactive invitation have two new options
    * Hide content on click - clicking it will close invitation without triggering widget open. E.g you have some sale running and want to share some code with users.
    * Custom on click event - in combination with above option can work as independent and just execute javascript on click.
* Users/Groups/Roles list/edit windows UX improvements. Sorts by module etc.
* Modifying department group will update it stats also now.
* Export CSV for survey option.

execute doc/update_db/update_285.sql for update

4.12v

* Start chat form settings can be assigned to more than one department.
* Custom start chat settings can switch department from dropdown option.
* Left dashboard menu will show alert icons also. https://github.com/LiveHelperChat/livehelperchat/pull/1796
* Loading previous messages will pay attention to departments operator has access to. https://forum.livehelperchat.com/viewtopic.php?id=4139

execute doc/update_db/update_284.sql for update

4.11v

Statistic saved reports can be send daily/weekly/monthly

execute doc/update_db/update_283.sql for update

4.10v

1. Reports various fixes.
2. Now you can save report for future reference.

execute doc/update_db/update_282.sql for update

4.09v

1. Optional reactions to bot messages. https://doc.livehelperchat.com/docs/bot/bot-text#reaction-options
2. Replaceable variables activity period.

execute doc/update_db/update_281.sql for update

4.08v

1. Bot messages can be automatically translated using Translation services.
2. Passed additional chat variables will prefill nick, email, phone.
3. Visitor now can switch his language in the widget.
4. Alert message will be shown if department groups permission is misconfiguration. Operator can edit them, but can't read.
5. Option to clone replaceable variable.
6. Now as admin I can edit more fields of the operator.
7. Files upload UX fixes. Messages not always was fetched after files upload.

execute doc/update_db/update_280.sql for update

4.07v

1. Additional chat columns can be sorted [Pending chats, Active chats] widgets supports

execute doc/update_db/update_279.sql for update

4.06v

Now there is an option to assign operator to department/department group and at the same time exclude him from auto assignment workflow.

E.g You have operators who works only with VIP department, but when they don't have much to do they want to accept chats manually from lower level departments. With that option you can do that.

* VIP Department chats will be auto assignment.
* But lower level chats they would need to take manually.

execute doc/update_db/update_278.sql for update

4.05v

1. You can have custom keyboard shortcuts for bot commands.
2. Commands now have --silent and --update_status options. Read about them on documentation.
3. Using above new features you can have a custom chat close shortcut add subject etc... Unlimited options.

execute doc/update_db/update_277.sql for update

4.04v

1. We will be able to read variable passed like this. In additional chat variables `Old way passed variable name` just enter `username`. This will improve compatibility with older embed codes.
```
LHCChatOptions =
  {
      "attr_prefill": [
          {
              "name": "username",
              "value": "remdex"
          }
      ]
  }
```
2. `{args.` will be supported in canned messages and canned messages replace variables. E.g `{args.chat.chat_variables_array.player.firstName}`
3. Various small bugfixes.

execute doc/update_db/update_276.sql for update

4.03v

1. Option to save bot response as template or quickly copy from another trigger.
2. Option to save trigger events as template.
3. If widget theme was used and theme has an image it should override bot logo.

execute doc/update_db/update_275.sql for update

4.02v

1. Visitors can download now chat as txt file. Can be turned off in the chat configuration.
2. Bot quick reply buttons now have option to set custom css class and icon content. Usefull while developing custom theme and using custom font.
3. Survey widget state will have an operator profile shown.
4. Various small changes for the widget modal windows. Paddings, button styles.
5. Mobile app was not transferring chat to another operator.
6. More CSS classes for widget elements to override them with custom CSS.

execute doc/update_db/update_274.sql for update

4.01v

1. Option to skip event listener.
2. Custom event for Rest API call for external logging.

execute doc/update_db/update_273.sql for update

4.00v

1. Option to cache Rest API request. Usefull if Rest API behaves just as intent, sentiment analysis because responses are always the same.

execute doc/update_db/update_272.sql for update

3.99v

1. Message aggregation for sentiment analysis per message implementation.
2. Small security fix
3. Possibility in statistic group by operator

execute doc/update_db/update_271.sql for update

3.98v

1. Option to share your views with other operators.
2. Scroll was at incorrect place in case message area was hidden.
3. Various other changes including security ones.

execute doc/update_db/update_270.sql for update

3.97v

1. Search by phone.
2. Security fixes. Update highly recommended.
3. Improvements to dashboard request frequency.
4. Edge case widget hide/show scenario fixes. Was not possible to close proactive invitation if status widget was acting as close button.
5. Operator will be in text grey (online operators widget) if he can't write to any department assigned.
6. Visitor hold option. You can pause auto responder for the `visitor not replying` if you know that visitor will take time looking for an info.
7. Delete action should wait until request is done.
8. Mobile app supports live online/offline status monitoring.
9. Dashboard left column will be always visible in any other page of LHC. Possible to hide/show it.
10. Admin chat interface will render presented buttons for the visitors.
11. Audit log list will have a quick view option as modal window.
12. Audit log will store all messages as JSON if not a string passed.
13. Online operator counter in the online operators widget. Will show exact number of operator whois online and has write permission.
14. More complex `secrethash` value generation during install. I would suggest for existing installation just write it quite long complex string with various special characters.

execute doc/update_db/update_269.sql for update

3.96v

1. Proactive chat invitation now supports multiple departments assignment
2. Proactive invitations now can filter directly `online_attr_system` key and values

execute doc/update_db/update_268.sql for update

3.95v

1. Proactive chat invitation dynamic conditions.
2. Messages auto scroll to reply position fixes.
3. force_logout attributes support for Rest API.
4. Highlight currently opened chat.
5. Permission to allow/deny operator visitor IP


execute doc/update_db/update_267.sql for update

3.94v

1. Block by online user. Basically it means a cookie based block. Online visitor tracking has to be enabled.
2. Widget will automatically adjust width, height on desktop devices.
3. Proactive invitation now can be expireable.
4. Online visitors widget will show read only departments groups.
5. If chat has remarks from previous chats tab will be highlighted.
6. Referer was passed incorrectly in so circumstances.
7. Security fixes
8. Added icons from the bot now is transaction wrapped.
9. In some cases Live Helper Chat did not returned correct data for mobile app.
10. Canned messages statistic tab will have more export capabilities.
11. If operator takes over a chat, we should terminate any previous information collection workflow.
12. Some refactoring to remove php-session dependency for anonymous visitors.
13. Proactive chat filter in chat list.
14. Commands should not be executed in whisper mode.
15. Subject add/remove events.

execute doc/update_db/update_266.sql for update

3.93v

1. Missing indexes fixes in some tables.
2. Whisper mode for the operator. We will go automatically to whisper mode if operator is not a chat owner.
3. Status widget icon fix in chrome https://github.com/LiveHelperChat/livehelperchat/issues/1733
4. JS API improvements for CloudTalk extension
5. Operator concurrent chats support while viewing specific chat. You can see how many other chats operator were having.
6. PHP-Resque in some situations were missing chat object.
7. And many other small changes

execute doc/update_db/update_265.sql for update

3.92v

1. In progress trigger option. This is usefull in case previous process has not finished yet. Mostly use case with custom extensions.
2. Users sometimes were logged out just after login if they were using auto logout after some interval.
3. I have started a progress to remove old legacy widget code from the app.
4. On password remind function show identical message in all cases to avoid scanning for existing customers.
5. Further PHP 8.1 fixes.
6. In statistic section now you can differentiate proactive chats was it manual invitation or automatic.
7. In case PHP-Resque was used and incoming webhook events were not send to Rest API
8. Get rid of document.write for a new widget to avoid warning.
9. jfif support as image format.

execute doc/update_db/update_264.sql for update

3.91v

1. Survey API. See a swagger survey section.
2. Fix tricky case if manager is monitoring a chat and chat being transferred to him, chat was not auto accepted. It will be now.
3. Mobile app now supports android notifications categories.
4. Further 8.1 PHP support improvements.
5. System tab will be remembered now on refresh.
6. If proactive invitation is used with bot append option we should not show next time invitation once a visitor closes it.
7. SVG Cleanup on upload for security reasons.
8. Operators statistic directly in online operators widget.
9. Department statistic link directly in pending/active chats widget.
10. CSRF token for logout link.
11. We now have zoom image option directly in the chat widget.
12. Pre chat conditions.

execute doc/update_db/update_263.sql for update


3.90v

Widget theme table columns type changes. On some MySQL servers it was returning that row size to big.

execute doc/update_db/update_262.sql for update

3.89v

1. Canned messages can be disabled now.
2. Further 8.1 PHP compatibility fixes

execute doc/update_db/update_261.sql for update

3.88v

1. Theme alias and Department alias.
2. PHP 8.1 compatibility fixes

execute doc/update_db/update_260.sql for update

3.87v

1. New trigger response type. `Log action` usefull in case you want to store historical chat actions.
2. Canned messages can have activity period. E.g some messages can be active during christmas period or just morning hours.
3. Chat export has more prefilled variables.
4. While sending manual message to online visitor it's possible to ignore bot.
5. Online hours operators statistic now has seconds filter.
6. Improved older PHP versions support.
7. PHP-Resque replaceable variables where lost during trigger process events.
8. Hide block by nick if visitor nick is "Visitor"
9. Large inactivity timeout values and custom permission to use them.
10. Region/State detection improvement for chats.

And many other changes all around

execute doc/update_db/update_259.sql for update

3.86v

1. Rest API access can be restricted only to Rest API keys.
2. Rest API keys themself can have IP restrictions
3. Bot Rest API call default trigger can execute selected trigger only one action.
4. Output parsing in Rest API calls, now can have two conditions.

execute doc/update_db/update_258.sql for update

3.85v

1. There is new event you can fire to trigger google analytics events directly from custom HTML of your widget.
2. Now you can explicitly control what one operator can change in other operator departments. https://doc.livehelperchat.com/docs/users/account-edit
3. In password change requirements you can force users to logout after certain period of last login.
4. You can automatically disable operator if from their last login passed X number of days.
5. In password requirements you can set bunch of other requirements for the password.

execute doc/update_db/update_257.sql for update

3.84v

1. Read only departments groups

execute doc/update_db/update_256.sql for update

3.83v

1. You can set view as passive, so it won't be updated in the background and will save resources.
2. User menu layout change and few options to change directly.

execute doc/update_db/update_255.sql for update

3.82v

1. Views - you can save a search as view and see always updated results in My views.
2. Forms now can update chat attributes. https://doc.livehelperchat.com/docs/modules/forms

execute doc/update_db/update_254.sql for update

3.81v

1. Canned messages usage statistic collecting option. Can be activated in statistic configuration tab. `Collect canned messages usage statistic`
2. Security fixes. All these were CSFR based issues which does not have much usage in real life scenario. Update is still recommended.

execute doc/update_db/update_253.sql for update

3.80v

1. Custom replaceable variables which you can define in back office. They also allow to set custom value based on chat attributes.
They are handled in bot responses also.

execute doc/update_db/update_252.sql for update

3.79v

1. Now you can block visitors by their e-mail address. Usefull in case you are passing this information.

execute doc/update_db/update_251.sql for update

3.78v

1. There will be no longer requirement to re-login after permission/department assignment changes.

execute doc/update_db/update_250.sql for update

3.77v

1. Migration to big int. Part 1
2. Few small widget fixes
 
execute doc/update_db/update_249.sql for update


3.76v

1. Canned messages can have subjects now su upon usage these subjects will be auto added to the chats.
2. Canned messages will have list of max 50 items returned.

execute doc/update_db/update_248.sql for update

3.75v

1. Option to blink active chat if visitor is waiting to log response from the operator
2. Chat routing will allow to forward chat directly to department.
3. Statistic will allow to export directly to CSV
4. Chat list export will have more fields in exported file

execute doc/update_db/update_247.sql for update

3.74v

1. Now you can send invitation message to mass users at once.
2. You can filter online visitors who are connected to website only. Using nodejshelper extension this gives live view who is connected.
3. Canned messages now can be assigned to more than one department.
4. Private messages between operators will have a sound now.
5. Canned messages import/export will support tags now.
6. Users import will have more fields to prefill now.
7. Department list will be sorted by same order as in the widget filters.

execute doc/update_db/update_246.sql for update


3.73v

1. Option to pass trigger_id as argument. Usefull in case you want to make some test on production.
2. You can now use in JSON payload Rest API call raw_{{lhc.id}} within quotes.
3. CSV export for chats listings.
4. UL,OL styling options. See bbcode documentation for a syntax.
5. Option to change font size from the widget. Can be activated in widget themes.

execute doc/update_db/update_245.sql for update

3.72v

1. Security fix for https://huntr.dev/bounties/1-LiveHelperChat/livehelperchat/
2. You can change sound option per invitation now. (Play sound or not)
3. Fixes for webhooks conditions being parsed incorrectly.
4. Now you can change order of start chat fields including custom fields you define in start chat form.
5. You can set titles for standard fields in widget theme now.
6. Now you can trigger offline form manually from website https://doc.livehelperchat.com/docs/javascript-arguments#open-offline-form-while-keeping-option-to-start-a-chat-normally
7. You can set default sound setting in widget theme. (Play sound for new messages or not)
8. Offline message will support BBCode now.
9. Rest API call will support now also x-www-form-urlencoded request type.
10. !block command did not worked.
11. Chat lists has direct option to filter abandoned chats https://doc.livehelperchat.com/docs/chat/statistic/#performance
12. Send message did not set nick if previous chat was not found. (Empty nick scenario)
13. Now you can login to back office using e-mail also.
14. If operator is not looking at online visitors widget we will not load it's content. Performance improvement.
15. New widget dropdown was missing click action support.
16. Users dropdown filter is now AJAX based and will filter directly.
17. NodeJS extension now support option to track online visitors live status or not.
18. Setting subject in the chat will sort subjects by their names.
19. Bot Execute JS will support replaceable variables also.
20. foreach cycle support in bot response https://doc.livehelperchat.com/docs/bot/bot-text/#foreach-cycle
21. Bot buttons will support translations also.
22. If visitor has closed chat there will be button invite support in chat messages.
23. Different color for a system message if visitor has left a chat.

There is no database update this time. So just replaces files.

3.71v

1. Duplicate online record was presented if old version JS files were cached.
2. Option to have event tracking settings by department.
3. Visitor typing text was not updating above text area
4. Automated hosting extension now supports PHP-Resque
5. Custom icons alerts will have a new sound
6. Dark theme edit previous message background changed to more readable.
7. Survey won't be shown to visitors who are blocked during conversation.
8. We will remember nick if chat is started in popup directly.
9. And various other small changes.

execute doc/update_db/update_244.sql for update

3.70v

1. Validation failure trigger option instead of validation message.
https://doc.livehelperchat.com/docs/bot/collect-custom-attribute
https://doc.livehelperchat.com/docs/bot/collecting-information-two-tries
2. Now you will be able to filter chats by visitor status at the moment of chat was closed. Help's to find chats which were closed before visitor left a chat.
3. BBCode selecting string applied style to wrong text if same text was presented multiple times in text area.
4. Auto responder will execute bot actions independently of messages. So you can have message or trigger to be executed on auto responder. https://doc.livehelperchat.com/docs/bot/operator-not-responding
5. Style fixes in case bot sends HTML style message.
6. If operator disables all fields we still should show department dropdown if there is more than one department to choose from
7. https://github.com/LiveHelperChat/livehelperchat/issues/1642
8. Optimised how online status is calculated. Performance improvement.
9. Some servers were caching GET request of URL it should not. Workaround for servers misconfigurations.
10. If chat is closed we will not update send_status

execute doc/update_db/update_243.sql for update

3.69v

1. Survey control from a bot - https://doc.livehelperchat.com/docs/bot/survey-control-from-bot
2. Scroll to the bottom UI for the operator and widget
3. Another option to close widget from website itself. Gracefully https://doc.livehelperchat.com/docs/javascript-arguments/#to-end-the-chat
4. Do not not close widget if automatic start chat is checked in widget themes.
5. Rest API file updated to support PUT, DELETE methods.
6. Custom post survey support - https://doc.livehelperchat.com/docs/integrating/custom-post-survey/

execute doc/update_db/update_242.sql for update

3.68v

1. Support fully https://github.com/open-wa/wa-automate-nodejs integration.
2. In widget themes you can set that chat remained in widget once was opened in a popup.

execute doc/update_db/update_241.sql for update

3.67v

1. Incoming webhooks support. You can integrate easily any third party API providers.

execute doc/update_db/update_240.sql for update

3.66v

1. Now you can also import/export Rest API configuration.
2. `Collect information` response type `Ask user to confirm information by checking checkbox` was not working.
3. `Check for conditions to proceed` response type now can check is there any operator online or not https://doc.livehelperchat.com/docs/bot/check-conditions/
4. Canned messages import changed the workflow so master-master replication won't break it.
5. Rest API name length changed from 20 to 50 characters

execute doc/update_db/update_239.sql for update

3.65v

1. In master/master replication environment canned messages import did not worked correctly because we did id's comparison. We now will have unique_id field for that.
2. Now you can move triggers between trigger groups.
3. There is now Rest API for files upload.
4. Bugfix - https://github.com/LiveHelperChat/livehelperchat/issues/1624
5. Rest API call now has {{msg_items}} and {{msg_all_html}} replaceable variables. https://doc.livehelperchat.com/docs/bot/rest-api#replaceable-variables
6. Percentages now are rendered at the top instead of the same line.
7. Javascript argument for default department if more than one department is passed. Related section - https://doc.livehelperchat.com/docs/javascript-arguments/#how-to-change-default-department-from-parent-page
8. Changing department in the widget will update it's fields now. You can have custom fields by department now.
9. Bot now supports file upload handling https://doc.livehelperchat.com/docs/bot/collect-custom-attribute#file-expecting-trigger-example
10. Rest API authentication method now supports NTLMauth. Thanks to https://github.com/ProsWeb
11. `addmsgadmin` now will support also system messages. https://api.livehelperchat.com/#/chat/post_restapi_addmsgadmin

And various other small changes :)

execute doc/update_db/update_238.sql for update

3.64v

1. Any form now can be integrated into a widget. https://doc.livehelperchat.com/docs/modules/forms/
2. Widget can have only pre chat form now only.
3. New widget was not respecting do not track online visitors setting.
4. Chat's can be searched by entering multiple id's
5. Some charts will show percentages at the top of column
6. Abandoned chats statistic
7. Forms were not exported to zip by clicking download icon.

execute doc/update_db/update_237.sql for update

3.63v

1. You can generate avatar for your profile.
2. Avatar for bot added.
3. Avatar in widget themes.
4. BB Code turn off/on support for a new widget.
5. Option to set full screen mode from embed code directly.
6. Fix. Voice message for the admin was broken.
7. Group chats won't be focused by default.
8. Tablets won't show widget in full screen mode.
9. Option to have hidden status widget in case of api position

Avatars are generated using https://multiavatar.com project

execute doc/update_db/update_236.sql for update

3.62v

1. E-mail templates can be translatable now
2. New widget now supports custom images for the header icons
3. Title attribute can be translated for the header icons
4. New dashboard left column can have lists instead of tabs layout.
5. Changes to support to NodeJS Extension. Now it can track live connectivity status of the visitor.

execute doc/update_db/update_235.sql for update

3.61v

1. Bot building interface will have option to set group position, expand collapse group triggers. Usefull if you have a big bot.

execute doc/update_db/update_234.sql for update

3.60v

1. Voice & Video & ScreenShare powered by agora.io. They give 10 000 call minits every month for free.
2. Option to reset counter from bot https://doc.livehelperchat.com/docs/bot/multiple-unknown-messages

execute doc/update_db/update_233.sql for update

3.59v

1. Option to automatically close the chats where visitor has abandoned them. In other words will close chats where pending widget row indicates that visitor has left the chat.
2. Option to do prefill offline message form. Usefull if bot redirects to offline form and you do not want that message area would be prefilled by previous covnersation.
3. Update chat -> Transfer to operator has now option to transfer chat to operator and ignore department online hours.
4. Internal failing of visitor sending messages will be logged in audit log. Usefull if you experiencing high load and want to investigate why it's happening.
5. Transactions will be used on remarks saving.
6. saveThis method was not respecting passed arguments to indicate what columns should be updated.
7. Department load statistic modal window.

execute doc/update_db/update_232.sql for update

3.58v

1. You can change TOS field text value directly in theme. E.g Our terms of service [url=http://livehelperchat.com]Live Helper Chat[/url]
2. There is new option to close all active chats based on last message.
3. Right chat column layout was changes
4. Screenshot from chat was not updating image if more than one chat was open at a time.
5. Mobile app will show notification if chat was transfered to an operator.
6. Option to reload widget theme on the fly. Usefull if your APP is switching between dark/bright themes.
7. Statistic for last 24 hours won't be generated if operator clicks a tab.
8. [html] tag will not be rendered for an operator to avoid bad operator scenario :D
9. We will try to assign default chat by departments priority.

execute doc/update_db/update_231.sql for update

3.57v

1. New widget offline form will support file field now.
2. Webhook has option to set alternative scenario of conditions are not met.
3. Change how soft limit is calculated for department load statistic.
4. Popup was not showing offline form even argument was passed in embed code.
5. Dashboard open chats has sub-tabs instead of list one after another.
6. Start chat custom field settings was not setting required attribute if not first one was checked.
7. Webhooks conditions can be applied to standard events now.
8. JS API to send messages as visitor from third party JS.
9. Images will show download icon always.
10. If sending message to chat fails we will show an error to visitor.

execute doc/update_db/update_230.sql for update

3.56v

1. Chat export will have modal window dedicated to chat's export with subject and messages types inclusion.
2. FB and Twilio extension has new documentation for easier understanding how to install.  https://github.com/LiveHelperChat/twilio https://github.com/LiveHelperChat/fbmessenger
3. Sandbox error for serviceWorker will be ignored. Edge case devices handling.
4. You can have notifications for active chats which get's alert icon assigned
5. You can now manual init widget JS and all it's dependencies https://doc.livehelperchat.com/docs/javascript-arguments/
6. Notifications won't be shown if you have many pending chats and change sort
7. If storing message fails we should show visitor what happened. So he can try again
8. We should also keep his last message attempt
9. Reduced number of renders checks in widget
10. Translations performance/cache improvements
11. You can override now also english translations - https://doc.livehelperchat.com/docs/language/#how-to-override-default-translations
12. If sending message from a new widget fails we will show now message for a visitor.

execute doc/update_db/update_229.sql for update

3.55v

1. Continuous webhooks.
2. Chat closing and other emails will include all chat messages.
3. You can have now custom JS in static url. "Events Tracking" window. Events in static URL still won't be tracked. It will be implemented in next releases.

execute doc/update_db/update_228.sql for update

3.54v

1. Update angular version and disable debug output.
2. Anyone who is using NodeJS extension will have to update it also.
3. Now you can manually choose what alert icons to exclude from dashboard lists.
4. "Check for conditions to proceed" now have option to continue execution even if conditions are matched.
5. "Check for conditions to proceed" can access any attribute through {args.chat.<any_attr>} E.g chat message {args.msg.msg}.
6. Alert icon now can have custom text as tooltip.

execute doc/update_db/update_227.sql for update

3.53v

1. Inactive chats for logged operator and active chats for logged operator stats in departments widget.
2. Live helper chat will work perfectly fine on devices where cookies, session storage and popups are disabled.
3. Popup refocus did not worked from react app.
4. Previous messages will be shown also for proactive invitation.
5. Pending chats wait time was calculated from start chat time, but in case bot transfer after some time it should be based on time since chat become pending.
6. Departments stats will be ordered by active chats number instead of pending one.

execute doc/update_db/update_226.sql for update

3.52v

1. Support for a browser with cookie, sessionStorage support.
2. Inactive chats statistic. This change was needed because auto assigned can exclude inactive chats. In that scenario statistic is misleading.
3. Offline form now can be without an e-mail field. So you can configure it to be with e-mail either phone.

execute doc/update_db/update_225.sql for update

3.51v

1. Departments statistic widget will have a new columns.
1.1 Bot chats - number of active bot chats
1.2 Load column - `hard limit` - `active chats` (`soft limit` - `active chats`)
`Hard limit` - is the sum of max chats value of logged operators who were active during last 5 minutes
`Active chats` - number of active chats in department or department group
`Soft limit` - is the sum of max chats of operators who were active during last 10 minutes.
1.3 Group chats list in departments statistic widget
2. If you have `php-resque` extension running. Departments statistic will be calculate in the background.
3. Changed background color of chat tab/left chat.
4. Rest API to fetch chat information https://api.livehelperchat.com/#/chat/get_restapi_chat__chat_id_
5. Check is audio is available on device.
6. Separate backend and frontend scripts. Performance improvement.
7. Frontend errors tracking in audit log. category - js, source - lhc. It has to be enabled in audit configuration.
8. Option to tell LHC are we running under proxy. Avoids faking IP address. https://doc.livehelperchat.com/docs/blocking/#live-helper-chat-does-not-detect-ip
9. If archived chat group chat table does not exists. Ignore.
10. Bot changes to handle previous process https://github.com/LiveHelperChat/livehelperchat/issues/1579
11. `Typing until` bot response fixes for a new widget.

execute doc/update_db/update_224.sql for update

3.50v

1. Login history.
1.2 You can force user to reset password on first login.
1.3 You can limit how many attempts operator has before his account is disabled.
2. Dark theme improvements.
3. You can set chat subject directly from bot. "Update current chat" -> "Set subject" command.
4. "Alert icon" response type. It will allow to add custom icon to a bot chat list. So you can quickly take over bot chat.
5. And many other changes.

execute doc/update_db/update_223.sql for update

3.49v

1. Now operators can have chat between themself directly in the chat.
2. Once clicking on a chat tab you can copy URL and chat will be opened.
3. Possibility to copy link to chat directly from chat window. Copy link action near the chat ID.
4. Dashboard icon from I icon was changed to home icon to match Dashboard icon.
5. HTML Element from bot will be rendered for an admin.
6. Blocking capability by IP or Nick or Nick and Department
7. Department archive attribute. These departments won't be shown in dashboard and in user account will be placed under `Show archived` button action.
8. Quote menu action for the right mouse click in messages area.
9. Widget was not showing error in case it was an error not related to a field.

execute doc/update_db/update_222.sql for update

3.48v

1. Global activity tracking. If you stop activity in one window it won't force go offline everywhere.
2. Includes database changes I'll need for future version.

execute doc/update_db/update_221.sql for update

3.47v

1. You can access now any argument in Rest API call. Usefull in webhooks.
2. Webhooks
3. Widget icons were not loading if PC already had Material Icons font. Thanks @AKapaceb
4. New chrome cookie policy support for chrome extension https://doc.livehelperchat.com/docs/chrome-extension/
5. Files will not be send as soon operator uploads them, we will add BBCode to them.
6. New arguments for custom status icon position.

execute doc/update_db/update_220.sql for update

3.46v

1. New positions for a new widget.

execute doc/update_db/update_219.sql for update

3.45v

1. Option to pass chat variable as invisible for an operators.
2. Option to have a log message on passed variable if it changes during chat session.
3. Mail transcript option
4. Change UX for department assignment to an operators. There was to many false reports and mixing between assigning department to operator.
5. Fixed auto login link generation.
6. RTL fixes
7. Co-browsing setup instruction changes https://github.com/LiveHelperChat/livehelperchat/blob/master/lhc_web/doc/node_servers/cobrowsing/README.md
8. Changes for easier docker support.
9. Draggable modal various small changes.

execute doc/update_db/update_218.sql for update

3.44v

1. Fixed few XSS vulnerabilities found by @rekter0 (Discord)
2. (real) to (float) changes. Thanks to https://github.com/swidbert
3. Widget will be shown as online if overload limit is reached, but there is bot setup in departmnet.
4. Device type export in chat list.
5. Updated GA tracking default template to sen event's to all installed site GA trackers.
6. Canned messages import/export
7. Draggable modals. Will remember position also.
8. Bot text messages now can be send as system messages. Usefull to represent some information just to operators.
9. Now in Rest API calls you can access any internal chat attribute.
10. Adjusted widget loading workflow for slow internet cases.
11. And many more small changes.

There is no database update this time.

3.43v

1. Commands based on bot triggers

execute doc/update_db/update_217.sql for update

3.42v

1. Option to do not store user typing text.
2. Mobile notifications workflow improvements.
2.1 We won't send notifications for messages if chat is pending. Only one notification about new chat will be send.
2.2 New chat notification won't be send if chat is started with a bot. Notification will be send only if chat becomes pending.

execute doc/update_db/update_216.sql for update

3.41v

1. Block listing window improvements.

execute doc/update_db/update_215.sql for update

3.40v

1. Release in preparation for official mobile app release.
2. Various other bot related changes.

execute doc/update_db/update_214.sql for update

3.39v

1. Security improvements regarding postMessage workflow.
2. In proactive invitation you will be able to choose on what device invitation should be triggered.
3. Text matching rules for bot now supports wildcard and preg_match rules. Please refer to documentation.
4. You now can prepend bot button directly in proactive invitation message.
5. Proactive invitation will show small logo image of the operator.
6. Slovakian siteaccess
7. If HTTP_REFERER header not found we check also HTTP_ORIGIN now.
8. !stopfiles will update visitor UI also.
9. Rest API methods to work with a user.
10. Proactive invitation if required can show full widget on invitation.

And many many more various changes...

execute doc/update_db/update_213.sql for update

3.38v

1. Bot conditional changes
2. Chinese three dialects added as possible language options.
3. Group chat tabs have indication about unread messages.

execute doc/update_db/update_212.sql for update

3.37v

1. Had to separate bot assigned to a chat to a separate column. This will allow us to generate some charts like.
2. Was the chat only with a bot or also operator was involved.

execute doc/update_db/update_211.sql for update

If you want to have capabilities to search by bot in the past chats you can run this script from your command line.

php cron.php -s site_admin -c cron/util/migrate_gbot_id -p 0

3.36v

1. "Always online" operator mode. Usefull if you are using telegram and are using Auto assignment workflow.
2. Auto responder has option to send notice to visitor if operator is speaking his language.

execute doc/update_db/update_210.sql for update

3.35v

1. Group chats between operators
2. More Rest API arguments for fetchmessages call
3. In prefill variables workflow you can now prefill any chat variable you want.
4. Files attatchement modal window is larger and has preview of images
5. Password field type for custom variables defined from back office.

execute doc/update_db/update_209.sql for update

3.34v

1. Canned messages new interface
2. Passing variable has option to be persistent. It means variable in online visitors list will be preserved even if afterward it won't be passed.
3. Offline messaging will respect priority and passed department.
4. If NodeJS is enabled we should not be executing check messages call. Because NodeJS does that for us.
5. Send Video in bot now supports iframes. So you can embed youtube video.
6. If department was assigned to department group, operators max_chats limit was not respected.
7. Rest API for adding user messages will return message data itself.
8. Co-browsing new modal window for requesting screen share.
9. Hash tag functionality for canned messages now has columns supports and left,right navigation between columns.
10. New line were not respected if image was send in between operator messages.
11. Canned messages has full HTML preview.
12. RFC6265 Compatible cookie
13. CLI Install update to recent version.
14. Few fixes for PHP 7.4.5 compatibility.

And a lot of other small changes...

execute doc/update_db/update_208.sql for update

3.33v

1. Cookie path argument.
2. Operator to operator chat improvements.
3. Admin fields now can be prefilled.
4. Hidden if prefilled option.
5. Option to define explicitly in back office on what domains caht will work.
6. If embed mode is used and leave a message is disabled and offline_redirect is provided. Live Helper Chat will redirect customer to provided page.
7. Notifications about new messages will blink page title.
8. Unread messages will be played only if page is not focused.
9. Option to disable javascript embed in other pages.

execute doc/update_db/update_207.sql for update

3.32v

1. Rest API Response trigger type. You will be able to integrate ant third party API easily.
2. Added protection against recursion if some messes around and calls itself in bot building workflow.
3. Option to set default actions for unknown button click.

execute doc/update_db/update_206.sql for update

3.31v

1. Updated .htaccess files so Live Helper Chat should work out of the box with subdomain installations.
2. PHP Session was starting where it should not have to. Will increase widget performance a little bit.
3. If widget was minimized and restored again popup was not showing proactive invitation.

There is no database update this time.

3.30v

1. Bot triggers enhancements.
1.1 Regrouped triggers by their complexity.
1.2 Repeat restriction trigger can be global or local per trigger.
2. New widget out of beta and now is preferred one.
3. Proactive will remain in the widget for all session once it's triggered. See how demo it works. It no longer disappears from widget on widget close.
4. Active operator chats were not updated when owner of chat changed because of transfer.
5. Metalanguage support everywhere.
6. Changes required for multiple clients support.
https://doc.livehelperchat.com/docs/chat/multiple-clients/
It required to change permission if your operators does not see anymore all users/operators see
https://doc.livehelperchat.com/docs/chat/transferring-chat/#my-operator-sees-only-to-him-assigned-departments-and-only-his-departments-operators
7. Update how default dashboard will look like for a new installations.
8. Operator passing in new widget
9. Static URL generation in embed widget window
10. Javascript native calls definition https://doc.livehelperchat.com/docs/javascript-arguments#public-methods
11. Canned messages search will be performed also in title. https://doc.livehelperchat.com/docs/canned/#canned-messages-in-chat-interface
12. RTL support for a new widget.
13. Connection problems will be reported in dashboard.
14. And many many more changes...

See weekly changelog videos
https://youtu.be/t2mzEE3sTss
https://youtu.be/wxsDE9rDpa4
https://youtu.be/SPyEX2EcWew
https://youtu.be/dEsB6XdWc9g

execute doc/update_db/update_205.sql for update

3.29v

1. Option to be informed about returning visitor.

execute doc/update_db/update_204.sql for update

3.28v

1. From themes you can change new widget dimensions directly.
2. Various new widget UI improvements.
3. Translations update.

execute doc/update_db/update_203.sql for update

3.27v

1. New widget. At the moment it's beta. It features rewritten widget implementation from zero. It's still missing few features but should be pretty stable now.
2. In themes there is option now to activate automatic language detection from browser headers. For existing installation it to work you have to edit language. System configuration -> Speech -> Languages

execute doc/update_db/update_202.sql for update

3.26v

1. Personal auto responder. Operators has to have permission "Uers" => "Allow user to have personal auto responder messages"
2. Rest API has methods for work with Department/Bot
3. Option to setup default checked charts.
4. And may more small changes :)

execute doc/update_db/update_201.sql for update

3.25v

1. Embeded live help widget also will track referrer page.
2. Toolbar above messages area.
3. Survey stars will be shown as stars.
4. Option to use redirect instead of internal load during start chat. This will avoid refreshing page and starting new chat each time. Can be set in start chat form settings.
5. Avoid invalid character shown if quates is used in translation for operator typing text.
6. Popup opening in widget will automatically load mobile layout. Possible to set this in start chat form settings.
7. Theme was not passed in auto start chat behaviour.
8. Automatic transfer between departments was not handled in auto start environment.
9. Option to change placeholder text in widget from themes.
10. Improve multiselect dropdown behaviour. Selected items will be shown at top.
11. Changed penging save message design to match chat style.
12. Toolbar for operator admin.
13. Once you set visitor nick it will be remembered for next chat sessions also.
14. Removed autofocus in widgets.
15. Hungarian language.
16. Autoresponder multi-language support fixes. Was not saving correctly checked languages.
17. New bot trigger type, execute always. This will allow specific trigger to be executed at any moment on bot chat conversation. Usefull to have it for visitor quickly switch to human.
It supports two "Chat start behaviour"
"Instant execution (Executes and continues workflow)" - this will execute trigger always and continue normal workflow.
"Instant execution and block (executes and blocks further triggers execution)" - this will execute trigger and will not continue normal workflow.
You can use second one to transfer chat to operator. This type of trigger has to have event defined.


execute doc/update_db/update_200.sql for update

3.24v

1. You can preload now widgets whcih will eliminate loading delay of widgets. (System configuration -> Chat Configuration -> Misc -> Preload widget. It will avoid loading delay after clicking widget)

execute doc/update_db/update_199.sql for update

3.23v

1. Proactive invitations now support Injecting HTML directly in website. Usefull if you want to show let say some custom modal window then mouse leaves a page.
2. Canned messages now supports HTML Injection also. So you can send like HTML body to website.

execute doc/update_db/update_198.sql for update

3.22v

1. New element in bot to restrict execute specific trigger defined number of times.

execute doc/update_db/update_197.sql for update

3.21v

1. Now in bot configuration you can select what bot logic it should include. So one bot can combine multiple bot's logic.
2. Option to have background worker for footprint updates. Usefull if footprint table is huge.
3. Rest api chat's fetching methods has delay attribute which can be used. To fetch chats only older than x seconds.
4. Bot now have new element which can search on chat start event. Usefull conbining various chat start logic.
5. Sort in bot fixed if two elements one by another is same type.

execute doc/update_db/update_196.sql for update

3.20v

1. Bot translations now can have separate images. So bot identity can be fully overridden now.

execute doc/update_db/update_195.sql for update

3.19v

1. Bot now can have translations. Usefull if you want have one bot, but a little bit different texts by department.
2. Copy messages now can include or exclude system messages.
3. Mobile invitations. On mobile devices icon will be shown that there is unread messages.

execute doc/update_db/update_194.sql for update

3.18v

1. Option in file upload configurator to setup meta tag clean up. Upon files upload from operators meta tag information for images can be removed.
2. Updated messages style so that images won't have bubble background if message is only smile it also won't have bubble background.
3. Additional chat columns now support object attributes. Additional can be turned of separately for chat and online visitors.

execute doc/update_db/update_193.sql for update

3.17v

1. Now in options you can set should be cookie set only for domain where javascript is embeded or also subdomains. Default behaviour does not change. This can be controlled also from js embed code directly also.
2. Updated PHPMailer

execute doc/update_db/update_192.sql for update

3.16v

1. Operators now will have ability to have their own personal themes. To operators role has to be assigned (Themes) "lhtheme" (Allow operators have their own personal back office theme)"personaltheme"
2. Various other changes related to bootstrap 4 migration.

execute doc/update_db/update_191.sql for update

3.15v

1. Audit log functionality.
2. Bootstrap 4.1.2, this is quite still early release. So if notice any design issues, let me know.
3. Canned messages now have toolbar for easier images insert.
4. New messages styles
5. Tooltip removed from dashboard items. You should click (i) icon to preview chat information.

execute doc/update_db/update_190.sql for update

3.14v

1. Various bot improvements. More flexible rules for triggers matching. Termination of bot workflow in the middle of sequence.
Bot conditions check.

execute doc/update_db/update_189.sql for update

3.13v

1. Various bot improvements. Intent detection by matching rules. Possibility to plug in various AI engines in the future.

execute doc/update_db/update_188.sql for update

3.12v

1. Events will store how many times it was executed so extension can forbid executing it second time.

execute doc/update_db/update_187.sql for update

3.11v

1. Option to have custom columns in dashboard chat lists based on additional chat data.
additional_data.<key || identifier>
chat_variable.<key || identifier>
2. Custom priority based on additional chat data.

execute doc/update_db/update_186.sql for update

3.10v

1. Remote API Keys support, this feature can be used by external API
2. Custom arguments based on javascript variables existing in embedded page. No need to generate custom Live Helper Chat code. You just define what variable should check LHC
3. Avoid PHP Sessions concurrent conditions if Redis is used as PHP Sessions handler.
4. Various bot improvements. New Datatype

execute doc/update_db/update_185.sql for update

3.09v

1. Password requirements configuration options
2. Option to have expirable password so after n days operators would have to change their password.

execute doc/update_db/update_184.sql for update

3.08v

1. Back office styling options
2. Option to have custom default messages box height
3. option to have custom default operators number in list

execute doc/update_db/update_183.sql for update

3.07v

1. Google re-captcha option for login page.

execute doc/update_db/update_182.sql for update

3.06v

1. Option to have custom text in themes for text like "You are number {number} in the queue. Please wait..."
2. Option to set default order for pending chats. Chat configuration -> Misc -> "Make default pending chats order from old to new"
3. Proactive invitation feature to have custom design for proactive invitation. Still not completed. But fields is presented already.
Proactive invitations if have same priority will be used randmonly. So A/B testing will make sense.
4. Gulp library updated.

execute doc/update_db/update_181.sql for update

3.05v

1. Filter online visitors by Country and Time On Site

execute doc/update_db/update_180.sql for update

3.04v

1. Proactive campaigns will be kept as long as online visitors records.
2. Option to configure how long to keep department availability statistic.

execute doc/update_db/update_179.sql for update

3.03v

1. Proactive chats A/B testing with campaign feature
2. Proactive chat efficiency tracking statistic. To track conversion rate.

execute doc/update_db/update_178.sql for update

3.02v

1. Chat lists will include proactive invitation filtering options
2. Statistic windows also will include invitation filtering options

execute doc/update_db/update_177.sql for update

3.01v

1. Auto assign enhancement. It can try to assign chats matching operators languages first. It can be per department enable/disabled
2. Auto refresh window for operators then version is updated.

execute doc/update_db/update_176.sql for update

3.00v

1. Various bot enhancements. Attribute element.
2. Option to setup automatic chat closing for active/pending/bot chats.
Responsible cron
php cron.php -s site_admin -c cron/workflow
3. Additional data attribute included in XLS export
4. Auto responder can send bot custom message.
5. Video type for bot
6. Allow to see generated bot syntax from bot builder interface
7. Option to have auto uppercase sentences in operator interface.
8. Rest api enhancements
9. Option to set how long chat can be opened after he was closed.
10. Show correct online status on widget minimization.

execute doc/update_db/update_175.sql for update

2.99v

1. New themes could not be saved.
2. Updated GEO ip detection section. Freegeoip was retired by owner.
3. Bot enhancements and subscription integration.
4. Auto responder can take bot trigger and send's it's meta data as additional data within message. Usefull if you want to show visitor Subscribe button.
5. Performance improvements be refactoring lh_chat table indexes.
6. Clicking subscribe button will show message in user messages window.
7. Updating user statistic in high load environment causes table locks. Added retry to that part.
8. Option to set referrer in google translations service integration.

P.s I really need somehow find time document bot properly. So much now with it can be done...

execute doc/update_db/update_174.sql for update

2.98v

1. Web push notifications for visitors.
2. Themes import allowed to upload php files. Security report by https://sentry.co.com

execute doc/update_db/update_173.sql for update

2.97v

1. Option to set bot/trigger for proactive invitation.
2. Possible to search by subjects in chats list and in statistic will be represented chart.
3. Various bot improvements/fixes.

execute doc/update_db/update_172.sql for update

2.96v

1. In themes possible to override Start chat, Leave a message button texts.
2. In theme custom field to have custom html above all input fields.
3. In bot mode possible to disable all fields and just have custom start chat with bot button.
4. Added option to change Collectable workflow cancel button text.
5. Added support for Collectable workflow to have cancel workflow button on error.
6. Custom edit icon in Collected summary.
7. Bot can have custom nick.
8. And various other bot fixes/improvements.

execute doc/update_db/update_171.sql for update

2.95v

1. Default trigger if visitor message is unknown.
2. Option to collect visitor phone/email through chatting.
3. Theme has custom status text for chat's going with a bot.

execute doc/update_db/update_170.sql for update

2.94v

1. Bot. First version of bot. Expected to be enhanced further a lot.

execute doc/update_db/update_169.sql for update

2.93v

1. Department availability statistic. In order for this statistic to be collection. This cronjob has to be setup.
* * * * * cd /home/www/<path_to_root_dir> && php cron.php -s site_admin -c cron/departament-availability > /dev/null 2>&1

2. Updated translations.

execute doc/update_db/update_168.sql for update

2.92v

1. Load previous button moved up, so visitor nick will be visible again for first message.
2. Option to anonymize visitor IP and messages after specific period of time.
3. In modern look, invitation will be hidden persistently on minimize action.
4. Header refactored on modern look.
5. Improved replacement algorithm for canned messages, then sometimes # hash was left after replace.
6. And many other small changes :)

execute doc/update_db/update_167.sql for update

2.91v

1. Modern look for widget.
2. If you had a theme for old style status widget it will still work. In theme there is option to choose what style widget to have. Old style or modern style.
3. Option to set required groups. So then operator is setuping new user he will have to choose one of required groups.

execute doc/update_db/update_166.sql for update

2.90v

1. Objects group model. Can be used in extensions to have custom permissions.
2. Further mobile improvements.

execute doc/update_db/update_165.sql for update

2.89v

1. Option to have persistent files. So they won't be deleted during files maintenance procedure.
2. More slick mobile layout
3. Various other fixes on mobile layout and consistency improvements.

execute doc/update_db/update_164.sql for update

2.88v

1. Chat now have chat start time, it different time than chat creation time. It maybe different if chat is closed and later reopened by visitor.
This situation can happen also with telegram chats and facebook chats. This change will allow us to have correct chat wait time based on time then chat became pending.
2. Change chat duration algorithm. Now chat duration will be based not on first and last message times. But on intervals between messages. You can also set timeouts.
there will be option to set two timeouts.
Timeout how long visitor can wait for a operator message before time between messages are exclude.
Timeout how long operator can wait for a visitor message  before time between messages are exclude.
3. More emoji conversion from text. Supported are
:), :D:, :D, :(, :o:, :o, :p:, :p, ;), ;(, :x, :*, ;*, :/
4. Fixed duplicate messages on window focus. Seems in rare cases then window was focused customer could receive same message twice if there was any pending message from operator.

execute doc/update_db/update_163.sql for update

2.87v

1. Subjects for chats.
2. Standard widget/Proactive invitation will be submitted using XHR request. This will avoid record in browser history.
3. FAQ, Questionry, Chatbox widget improvement toa void error in "messages"
4. Emoji icons for chats.
5. Search in chat list by user group or department group.
6. Statistic by week.
7. Sync offline/online icon in cross window environment. Child window will detect activity and report to parent window to avoid false positive for inactivity.
8. Footprint cleanup algorithm change for high load environment.
9. Bigger font size on mobile devices so scaling of widget won't be triggered.
10. Search by subject is not yet supported will be added in the upcoming releases.

execute doc/update_db/update_162.sql for update

2.86v

1. Option to allow read only chats. In user account editing window you can choose what type of assignment it should be. Read only or write also.

execute doc/update_db/update_161.sql for update

2.85v

1. Database charset changed to utf8mb4 to support emoji

execute doc/update_db/update_160.sql for update

2.84v

1. Option to delay status widget show.
2. Option to delay tooltip show.

execute doc/update_db/update_159.sql for update

2.83v

1. Autoresponder now supports custom nick. Multi language also supported.
2. Chart charts can exclude or include only offline requests.
3. Transfer to chat modal window now allows to change chat owner directly. "lhchat","changeowner" (Allow operator to change chat owner) is required.
4. User account window allows to change operator online/offline status directly.

execute doc/update_db/update_158.sql for update

2.82v

1. Quote selection sometimes forced chat messages to collapse.
2. Option to have online visitors and their footprint cleanup from cronjob.

execute doc/update_db/update_157.sql for update

2.81v

1. Delays for proactive invitations.
2. Quoting functionality. Just select a text in message.
3. Survey results export in XLS, JSON, XML
4. Dashboard widgets filtering by users, users groups, departments groups.
5. Forbid sending messages to chat once visitor was redirected to survey.
6. New colours for chat messages.
7. Above messages block will be shown time since last user message.
8. Chat duration will be dynamically updated. It's either chat duration from first and last message or time since chat start if chat is not closed.

execute doc/update_db/update_156.sql for update

2.80v

1. Multilanguage support for canned messages and auto responders.
2. Survey grouping fix
3. Save user browser language within chat.
4. Reopen chat in same place then chat information was edited.
5. Archive enhancements
6. Video embed support

execute doc/update_db/update_155.sql for update

2.79v

1. Automatic chat archive options.
execute doc/update_db/update_154.sql for update

2.78v

1. Option to set delay, between new chat can be assigned to operator since last assignment.
2. Option to have auto chat acceptance. If chat is automatically assigned it's possible now that new chat will be opened automatically to operator.
3. Option to exclude operator from participating in auto assign workflow, even if he is online.
4. Option to ignore inactive chat's in auto assign workflow.

execute doc/update_db/update_153.sql for update

2.77v

1. Option in auto responder to choose show proactive invitation on mobile or not.
2. Chat list filter by Chat wait time and Chat duration interval.
3. Harden protection against empty visitors messages.
4. Locking user department table by id to avoid deadlocks in high load situations.
5. Autologin workflow improvements.

execute doc/update_db/update_152.sql for update

2.76v

1. Option to hide message time from visitor in theme.
2. Option to set custom mobile width trigger point.
3. Changed how lh_userdep is table records are updates, avoids deadlocks in high load situations.
4. Support {department} in send mail to visitor subject and body

execute doc/update_db/update_151.sql for update

2.75v

1. Auto responder improvements and handling phone/tablet users if sync timeouts.
2. Auto login section to generate static auto login links.
3. Allow to filter in transfer window by online and logged in statuses.
4. Survey now supports charts for Questions and Answers. Support for [fs<number>][/fs<number>] and [value=5] support for questions and answers to have fixed answers.
5. Possibility to import users from CSV files.

execute doc/update_db/update_150.sql for update

2.74v

1. Option to set auto assign workflow priority by time.
2. Various small changes.
3. Translations updated.

2.73v

1. Auto responder now have On-Hold functionality.
1.1 If chat is on hold, no survey redirection will be executed. Usefull if you just want visitor to wait until you find some info.

2.72v

1. Offline requests are stored as chats
2. To proactive invitation now can be assigned auto responder.

2.71v

1. Option in autoresponder to set visitor redirection to survey if visitor does not respond for n seconds.

execute doc/update_db/update_145.sql for update

2.70v

1. Option to configure what should happen on transfer to department.
a. Leave assigned user or not
b. Make chat status pending or not
c. Remove assigned user or not.

2. Option for operator to configure show alert or not then chat is transferred directly to them.
3. If chat is transferred to operator and operator opens chat directly from transfer record will be removed also.

execute doc/update_db/update_144.sql for update

2.69.1v

1. Just small extra fix for start chat forms functionality.

No database updates involved.

2.69v

1. Option to overide start chat settings by department. They will be used only if department id is provided in embed code generation.
2. Encrypted fields support in proactive chat

execute doc/update_db/update_143.sql for update

2.68v

1. Option to style popup window with custom css

execute doc/update_db/update_142.sql for update

2.67v

1. Chat's will track in what state operator was while he was accepting chat. This will be used in Agents statistic.
2. If widget is closed in one tab it will be closed in another one also.

execute doc/update_db/update_141.sql for update

2.66v

1. Identification was last message seen by visitor or not.
2. Moving mouse over icon will show time since last sync.

execute doc/update_db/update_140.sql for update

2.65v

1. Autoresponder enhancements. See official announcement for changes.

execute doc/update_db/update_139.sql for update

2.64v

1. Option to setup department offline automaticaly if pending chat's number reaches defined number.

execute doc/update_db/update_138.sql for update

2.63v

1. Invitations now can have events. Tutorial under way.

execute doc/update_db/update_137.sql for update

2.62v

1. UX improvements for chat's between operators
2. Dynamic proactive events. It's possible to setup proactive invitation based on user iddle time and mouse leaving a screen.
3. It's possible now to speak and edit text at the same time.

execute doc/update_db/update_136.sql for update

2.61v

1. Workflow improvements for chat between operators

execute doc/update_db/update_135.sql for update

2.60v

1. Possible XSS attack patch by faking HTTP_X_FORWARDED_FOR headers. https://github.com/LiveHelperChat/livehelperchat/commit/eee03f77f3f51fed613c5e306152ea60255edba2
For quick fix you can just add this line https://github.com/LiveHelperChat/livehelperchat/commit/eee03f77f3f51fed613c5e306152ea60255edba2#diff-530588a4db273d4c39a44978784df71eR20
2. Various other small UX fixes

No database updates this time.

2.59v

1. During group editing you can choose with what groups members of this group can work with.  That means if operator is assigned to Operators group he will be able to work with only with groups defined in the list or the one he is assigned to.

execute doc/update_db/update_134.sql for update

2.58v

1. Option to track online operators activity so they will go offline automatically if no activity is detected for certain amount of time.

execute doc/update_db/update_133.sql for update

2.57v

1. Canned messages with hashes. Just type # and get suggested canned messages.
2. In canned messages edit window you can enter tags, tags has to be separated by ","

execute doc/update_db/update_132.sql for update

2.56v

1. REST API for registering mobile devices. Perhaps someone in the future will make open source app etc.
2. And just various small fixes.

execute doc/update_db/update_131.sql for update

2.55v

1. Device type detection
2. Option to filter by nick active and pending chats widget
3. Notifications workflow refactored, just to simplify the code
4. Issues/Improvements
https://github.com/LiveHelperChat/livehelperchat/issues/955
https://github.com/LiveHelperChat/livehelperchat/issues/960
https://github.com/LiveHelperChat/livehelperchat/issues/967
https://github.com/LiveHelperChat/livehelperchat/issues/983
https://github.com/LiveHelperChat/livehelperchat/issues/987
https://github.com/LiveHelperChat/livehelperchat/pull/979
5. Accesibility changes according to reports
6. Animation fixed, once message is send it was not possible to user scroll for some time
7. Theme adop to mobile devices, widget display and widget status
8. And many other small fixes.

execute doc/update_db/update_130.sql for update

2.54v

1. If pending chat is assigned to any operator, it's name will be shown.
2. Reduced font size of lists in right column
3. New variables for templates content {survey}, {chat_duration}, {waited}, {created}, {user_left}
4. If chat is automatically closed it will be unmarked as unread
5. Survey results also will be seen in survey popup which are called in chat window directly.

execute doc/update_db/update_129.sql for update

2.53v

1. Option to transfer chat to another operator directly with !transferforce command
!transferforce <username | email>
2. Option to transfer user to survey by choosing survey itself.

execute doc/update_db/update_128.sql for update

2.52v

1. Option to redirect user to survey in the middle of the chat. At the moment it works only in the widget mode. Not full chat mode. Will be updated in the future.
2. Option to have always open last 10 visitor active chats.
3. Chat will not scroll to the bottom if visitor scrolls chat at the top and visitors writes a new message.

execute doc/update_db/update_127.sql for update

2.51v

1. Departments groups. Departments groups option will appear in user account under Assigned departments if atleast one department group will be defined.
2. Option to set departments online hours per day or define nonworking/working days custom hours.

execute doc/update_db/update_126.sql for update

2.50v

1. Now it's possible to inform user about unread messages from operator.
2. In survey editing window you can choose what fields are required and what not.
3. You can now prefill also proactive invitation.

You have to have running for first enhancement.
php cron.php -s site_admin -c cron/workflow

execute doc/update_db/update_125.sql for update

2.49v

1. Survey now can have custom fields

execute doc/update_db/update_124.sql for update

2.48v

1. XMPP Support for PHP7
2. Full height layout update for proactive invitation
3. Proactive invitation now supports tag

execute doc/update_db/update_123.sql for update

2.47v

1. REST API call to change operator status to online/offline
2. Google Maps API update. You can now have google maps API key defined in back office.
3. On mizimize header of widget was hidden, it's fixed now.
4. And a lot of others small changes.

execute doc/update_db/update_122.sql for update


2.46v

1. Option to disable iframes rendering. It just increases security in some cases.
2. href links in co-browsing will be replaced with javascript:void(0), so in order operator to click invalid link he will have to type it manually.

execute doc/update_db/update_121.sql for update

2.45v

1. Admin themes
execute doc/update_db/update_120.sql for update

2.44v

1. Rest API Initial version

execute doc/update_db/update_119.sql for update

2.43v

1. Chat lists will have option to filter by product
2. Chat's widgets can be filtered by product
3. Custom field in users account which would be used instead of Name surname if filled.

execute doc/update_db/update_118.sql for update

2.42v

1. Product concept, few products can be assigned to single department [Sponsored]
2. Passwords are stored using password_hash function. [Improved security]
3. Cleanup user part [General]
4. 5.4 PHP required
5. https://github.com/LiveHelperChat/livehelperchat/issues/789
6. Option to securely encrypt passed data to additional form data. [Sponsored]
7. Paid chats concept, tutorial article is comming. [Sponsored]

execute doc/update_db/update_117.sql for update

2.41v

1. New statistic - unanswered chats. Chat becames unanswered if

a. User starts chat and there is message field and chat is pending.
b. Operator accepts a chat but visitor has already closed chat widget chat remains unanswered.
c. If chat started in proactive mode and user filled message and chat is not accepted yet.
d. Unanswered chat flag is removed.

2. User row has 3 additional attributes which can be used for extensions.
attr_int_1
attr_int_2
attr_int_3

execute doc/update_db/update_116.sql for update

2.40v
1. Option to force close chat on widget close button. At the moment it just closes widget. But on operator side there is no indication for that. 
2. Custom field for sort priority
3. https://github.com/LiveHelperChat/livehelperchat/issues/800
4. https://github.com/LiveHelperChat/livehelperchat/issues/810
5. https://github.com/LiveHelperChat/livehelperchat/issues/803
6. https://github.com/LiveHelperChat/livehelperchat/issues/796

execute doc/update_db/update_115.sql for update

2.39v

1. https://github.com/LiveHelperChat/livehelperchat/issues/772 - option in theme to define optional field which would be visible in department
2. https://github.com/LiveHelperChat/livehelperchat/issues/715
3. One more time new chat messages interface. Messages can be styled in theme editing window.
4. Option to turn off/on voting thumbs
5. Option to have custom text instaed of Department. Let say location.

execute doc/update_db/update_114.sql for update

2.38v

1. https://github.com/LiveHelperChat/livehelperchat/issues/771
2. Option to enable disable need help widget directly from theme.

execute doc/update_db/update_113.sql for update

2.37v

1. User can drag and sort frontpage widgets as he wants. Widgets order and what widgets user can see are based on user individually.
2. Canned messages are sorted by position and title now.
3. Other small UX updates.

execute doc/update_db/update_112.sql for update

2.36v

1. User activity tracking on site enhancements. New tab in settings "Visitor activity"

execute doc/update_db/update_111.sql for update

2.35v

1. Option to have a survey at the end of chat. This mode is written in flexible way so most likely it will be mutch more improved over time. At the moment only stars evaluation at the end of chat is possible
2. New icons - https://www.google.com/design/icons/
3. Left menu
4. In start chat you can enable automatic start chat as soon visitors types atleast one key.
5. And various others UX and performance improvements.
6. For update just follow standard update procedure For manual update it's update_110.sql

execute doc/update_db/update_110.sql for update

2.34v

1. Unfilled forms fields will be highlighted
2. Security improvements
3. Option to prefill custom fields which were added from back office.
4. https://github.com/LiveHelperChat/livehelperchat/issues/701
5. https://github.com/LiveHelperChat/livehelperchat/issues/700
6. https://github.com/LiveHelperChat/livehelperchat/issues/699
7. https://github.com/LiveHelperChat/livehelperchat/issues/694
8. Tooltips changed to bootstrap popovers
9. https://github.com/LiveHelperChat/livehelperchat/issues/702
10. Translations won't translate BBCode

There is no required database update for this release.

2.33v

1. Transfered chats as widget.
2. Updates required for XMPP support.
3. New algorithm for sound and notifications. Sound stops after pending chat is gone.
4. Option to delete pending chat instantly.
5. Position queue. https://github.com/LiveHelperChat/livehelperchat/issues/635
6. Option to set automatically checkd Terms Of Service checkbox
7. Desktop client will show only only visitors which user has permission to see.
8. E-mail templates supports {chat_id}
9. Permission UX https://github.com/LiveHelperChat/livehelperchat/issues/690
10. Optimizations for excel generation https://github.com/LiveHelperChat/livehelperchat/pull/688
11. Option to hide right column in frontpage.
12. Department XMPP recipients column change to text https://github.com/LiveHelperChat/livehelperchat/issues/686
13. Statistic improvements.

There is no required database update for this release.

2.32v

1. Brand new dashboard. Sponsored feature...
2. Few optimizations in back office sync calls.
3. Dashboard has new widget for department statistic.

execute doc/update_db/update_109.sql for update

2.31v

1. Option to enable only one logged user under same account in settings/settings.ini.php
Please add under "site" section 
'one_login_per_account' => false,
2. Automatic translations kept recording old translation settings.
3. Visitor will be able to see chat for rest half hour once it was closed.
4. Responsive logo
5. Collapse expand right panels
6. And a lot of other internal small changes.

execute doc/update_db/update_108.sql for update

2.30v

1. Canned messages have three additional integere attributes which can be used in extensions
2. https://github.com/LiveHelperChat/livehelperchat/issues/670
3. Canned messages now has fallback option. Let say if original message does not have a replacable variable canned message will be the fallback one.
4. In custom form fields there is new field "Field identifier" it can be used in canned messages.
5. A lot of override options. Usefull for extesnions.
6. Bunch of dispatches events around a places. Just gives more flexibility without overriding all module file.

execute doc/update_db/update_107.sql for update

2.29v

1. One more flow of internal changes and flexibility enhancements. Basically while building commercial plugins I'm extending core with more templates overrides and 
events
2. Three new attributes in departments which can be used in extensions.
3. Few fixed regarding user arguments variables. It was lost during form submitting. It was effecting only extensions.
4. Custom forms field can be managed from back office. Basically admin can add custom fields directly from back office. No need to use Javascript.

execute doc/update_db/update_106.sql for update

2.28v

1. Internal changes regarding co-browsing. Support for co-browsing session based on online visitor. These changes were done to allow plugin initiate co-browsing session without a chat. This is pure for extensions purposes. No UX changes.
2. NodeJS-Helper plugin update, chat became offline if no actions were processed for online timeout period. This happened only if NodeJS with publish notifications were used.
3. Chat start chat will have automatic height for first time. UX improvement 

execute doc/update_db/update_105.sql for update

2.27v

1. Autologin module. Read site how to use it. It's simplifies integration with third party CMS. By default it's turned off.
Example also available at doc/autologin/autologin.php
This module was sponsored by the way.

2. And a lot of templates split's in order for automated hosting to allow easier enable disable features
 
execute doc/update_db/update_104.sql for update

2.26v

1. Widget theme has new tab where you can enter most important text.
2. SMTP failing sending if forgot password window.
3. Separation templates based on features. It's all hard work because of upcomming new Automated hosting version.
4. Offline text styling then operator are offline. Just language select was taking a whole space.
5. Theme variable was not passed on some cases.

execute doc/update_db/update_103.sql for update

2.25v

1. Posibility to disable groups. Thats the only stuff will be done regarding https://github.com/LiveHelperChat/livehelperchat/issues/626
2. Company name for theme. https://github.com/LiveHelperChat/livehelperchat/issues/644
3. Option to provide chatbox name. E.g 
For page embed code
var LHCChatboxOptionsEmbed = {identifier:'default','nick':'remdex44','chatbox_name' : 'custom name'};
For standard widget
var LHCChatboxOptions = {identifier:'default',status_text:'Chatbox','nick':'remdex44','disable_nick_change':true,'chatbox_name' : 'custom name right'};
https://github.com/LiveHelperChat/livehelperchat/issues/643

4. System messages won't be shown in messages send to user
https://github.com/LiveHelperChat/livehelperchat/issues/645

5. Co-Browsing now does not require dedicated sub-domain. It can use same domain sub-locations. This will save some users funds like they won't have to buy ssl for sub-domain
See doc/node_servers/cobrowsing

6. Operator now has ability to request permission to selected module. [Sponsored]

7. Many parts were splitted into separte templates to prepare for new features in automated hosting [Sponsored]

execute doc/update_db/update_102.sql for update

2.24v

Sponsored release
1. Automatic messages translations using Bing or Google translations service.
2. Futher Bootstrap fixes. Were missing some places with old foundation 4 syntax.
3. A little bit refactored chat window. Removed subtabs.
4. Microphone settings moved to actions block and in it's place added automatic translations button.
5. Allow operators to chat even if they do not have permission to open others operators chats. https://forum.livehelperchat.com/viewtopic.php?id=1019
6. Right columns nicer interface
7. Co-Browsing scroll sync stopped to work after jQuery update. Switched to native JS API

execute doc/update_db/update_101.sql for update

2.23v

1. Integrated webpack, bower, gulp and other fancy stuff.
2. LHC was migrated to Bootstrap v3.3.2. I had tough choise decing stay with Foundation or use Bootstrap, but for systems Bootstrap just is more nicer.
3. A lot of code rewrite, CSS cleanup and so on.

2.22v

1. All Javascript's is now compressed.
2. Option to set notes for online user. If you click first user icon in popup the last tab will be notes. https://github.com/LiveHelperChat/livehelperchat/issues/613
3. Delete, Close icons will represents actual user permissions. https://github.com/LiveHelperChat/livehelperchat/issues/614
4. Online users list will have lest icons in last column.
5. New maxmind database for countries
6. Identifier variable for forms.
7. Option to force to use user e-mail as from address in e-mail templates. Use with caution because most cases Gmail could consider mails as spam. But usefull with integration with third party ticket systems.
8. Option to set how many times repeat autoresponder message. This can be set in proactive invitation and autoresponder itself also.
9. Map icon click will open full size Modal window instead of Marker popup.
10. Embed code generation window will check that domain would not contain protocol.

execute doc/update_db/update_100.sql for update

2.21v

1. Option to change front page tabs order in chat configuraiton section. (Misc)
https://github.com/LiveHelperChat/livehelperchat/issues/593
2. Option to set Sender e-mail for all aplication.
https://github.com/LiveHelperChat/livehelperchat/issues/598

execute doc/update_db/update_99.sql for update

2.20v

1. Speech to text support. Only google chrome at the moment has this hTML5 API
2. Theme variable was not forwarded internally. (During read operator message action)
3. Relative position for iframe. Some sites are using nonsense iframe positions.
4. Operator typing issue was fixed. Operator typing message was shown and was not shown again even if operator was still typing
5. Text preview position was changed.
6. Various co-browsing improvements.

execute doc/update_db/update_98.sql for update


2.19v

1. More attributes for themes
Restore, Popup, Close, Miminize images
Hide close, Hide popup options in theme.
Header widget height and padding options
Main widget border width option

2. Cookie conflict fix with third party libraries

3. Now operator can follow user scrollbar position

execute doc/update_db/update_97.sql for update

2.18v

Co-Browsing enhancement release part 2
1. Select box change will be synced to user browser also.
2. If your site is using jQuery JS library highligh elements selection will be more precise. 99.99% of accuracy. 
3. User actions on forms will be synced to operator browser. That means while user is filling a form you will see what fields he fills instantly, 
what checkboxes checks and so on. This feature requires jQuery JS library on remote site.
4. You can choose to execute or not javascript on Operator Co-Browsing window. Option available in Co-Browsing options.

execute doc/update_db/update_96.sql for update

2.17v

Co-Browsing enhancement release

1. Now from co-browsing window you can highligh elements. Just click left mouse cursor on desirable element.
2. If you click link hodling CTRL browser on user side will click this element to. This means you can navigate user browser where you want.
3. At top bar there is now network icon. If you click it you can navigate user preciselly to URL you want. You can navigate user to another url also from chat window. There is new icon for that
4. You can fill some of the forms fields by holding CTRL+Left mouse click. As field becames with blue shadow you can fill text fields on visitor browser directly. Fill forms for users :)
5. NodeJs server for Co-Browsing was updated.
6. You can can allow user to see your mouse pointer on his screen.
7. You can force user browser to scroll to highlighted element by checking checkbox at top.
8. Operator Co-Browser window will represent exact view of user browser. This is required to match mouse positions.

execute doc/update_db/update_95.sql for update

2.16v

Release with one mega feature. Co-Browsing - see exactly what your users see and help them to navigate.

1. This feature works even on standard server without special software. But if you want to use at it's maximum runing node server is required.
Inspiration come from, without these libraries it would be impossible to do all that :)
https://code.google.com/p/mutation-summary/
https://github.com/abbakym/mutationsummary-cobrowsing-experiment
http://teft.deviantart.com/art/Obsidian-Cursor-set-78972293

execute doc/update_db/update_94.sql for update

2.15v

1. Option to choose auto responder for specific department.
https://github.com/LiveHelperChat/livehelperchat/issues/547

2. Option to allow send file in offline chat form
https://github.com/LiveHelperChat/livehelperchat/issues/370

3. Instead of banning e-mails which are very easy to fake, there is option to ban not only single ip but also IP ranges.
https://github.com/LiveHelperChat/livehelperchat/issues/546

4. Will be recorded time when user has left a chat
https://github.com/LiveHelperChat/livehelperchat/issues/535

5. Adjusted position of user typing text indicator
https://github.com/LiveHelperChat/livehelperchat/issues/532

5. Posibility to edit main chat information. At the moment only user nick and e-mail address
https://github.com/LiveHelperChat/livehelperchat/issues/504

execute doc/update_db/update_93.sql for update

2.14v

This release is maintenence release with few enhancements

1. Option to pass identifier. It can be either some specific value or if not provided it will be referer URL.
Also new variable in template can be used {url_view} it will be link to filled form view instead of download link.
https://github.com/LiveHelperChat/livehelperchat/issues/563
2. Chat window in browsing information tab will show is user on page still or not. Option "Track is user still on site, chat status checks also has to be enabled" has to be enabled.
3. Different message will be shown then user starts chat from chat popup instead of chat widget. Like then user navigates to another window from widget it's shown URL to which he navigated. Then user decides to open popup for chat it will be different message.
4. Invitation to chat will also pay attention to additional fields attributes. https://github.com/LiveHelperChat/livehelperchat/issues/540
5. Proactive messages retargeting. In returning message field you can enter {nick}, if we will find a previous chat associated with this online user, nick from previous chat will be used if not proactive invitation nick field value will be used. 
https://github.com/LiveHelperChat/livehelperchat/issues/544

execute doc/update_db/update_92.sql for update

2.13v

This realease is maintenence release with a lot of small changes.

1. Updated xml module to return unread chats list also
2. Move events for NodeJs extension
3. Changed autoload mechanism to be compatible with third party autoloads. Replace index.php file
4. XML module was missing some callbacks which are present in web interface
5. A lot of small updates to to be compatible with newest NodeJS version.
6. En https://github.com/LiveHelperChat/livehelperchat/issues/511
7. If user navigated to another page sometimes user was shown as offline, even if user was online.
8. Not required interface sync was removed in popup window.
9. Cache for emoji icons https://github.com/LiveHelperChat/livehelperchat/issues/503
10. Sound for unread messages will be played https://github.com/LiveHelperChat/livehelperchat/issues/505

There is no database update in this release. 

2.12v

1. Now you can have fully functional and working minimalistic chat start form.
2. In themes there is option to upload operator image and write your own text for operator intro.
3. Minimalistic interface settings can be configured at "Start chat form settings"
4. Fixed bug then JS produced error if no live operator status check was enabled.
5. Send button is hidden if there is only one field
6. Pressing shift+enter won't submit form.
7. If user is redirected to contact form, within chat we will save user email if it's required.
8. Implemented https://github.com/LiveHelperChat/livehelperchat/issues/499
9. Option to embed code just to track online visitors. Can be used just as JS API embed solution.
https://github.com/LiveHelperChat/livehelperchat/issues/496

execute doc/update_db/update_91.sql for update

2.11v

1. Fixed bug then department online hours was not taking effect if department ID was not provided.
https://github.com/LiveHelperChat/livehelperchat/issues/491

2. Option to setup status indication is site visitor still on site or already left a site.
https://github.com/LiveHelperChat/livehelperchat/issues/490

3. Option to export chats as XLS
https://github.com/LiveHelperChat/livehelperchat/issues/435

4. Option to write manually for what domain user is generating embed code. This is neede if you are experiencing some issue like chat is not kept while navigating through other site pages.
Personally I always recomend to write it while generating embed code.
https://github.com/LiveHelperChat/livehelperchat/issues/489

5. Extra modules will be hidden if user does not have permission to use atleast one of submodule.
https://github.com/LiveHelperChat/livehelperchat/issues/487

6. If user refreshed page message time was incorrect because user time zone was not used. It was used only for new user messages.

execute doc/update_db/update_90.sql for update

2.10v

1. Now then you are genrating code for multiple departments, or just standard code without any department. 
If user chooses offline department for him is suggested go to leave a message form. This can be turned on or off in chat configuration. 
https://github.com/LiveHelperChat/livehelperchat/issues/477
2. On devices, with lower screen width than 1024, clicking on widget will open new window.
3. Default line height was set for widgets to have same appearance across all sites.
4. Option to set department online hours in hours and minutes format. Previously it was only hours. All users who uses this function is required to update department online hours. Just resave.
https://github.com/LiveHelperChat/livehelperchat/issues/476
5. Jersey icon was missing
https://github.com/LiveHelperChat/livehelperchat/issues/478
6. Now extension can override translations also. Just create a folder translations in your extension and appropriate language file.
E.g extension/overridetranslation/translations/lt_LT/translation.ts and active extension overridetranslation, and you are ready to go.
https://github.com/LiveHelperChat/livehelperchat/issues/479
7. Online visitor pages remmebers user settings, selected department, max records to return etc...
https://github.com/LiveHelperChat/livehelperchat/issues/474
8. Core was changed to avoid warning if compiled module file is not found. Actually it's like workraound for OP Cache then file is still returned from OP Cache instead of real one.
9. Option to enable language switched at chat widget. It applies only for chat widget and start chat windows.
https://github.com/LiveHelperChat/livehelperchat/issues/469
10. Install by default will enable Geo detection using MaxMind

execute doc/update_db/update_89.sql for update

2.09v

1. https://github.com/LiveHelperChat/livehelperchat/issues/428
2. Albanian language
3. Chats duration algorithm was changes it now will calculate chat duration by this algorithm
last user message time - (chat start time + chat wait time). You can update all your chats duration by visiting chat Maintenence page.

execute doc/update_db/update_88.sql for update

2.08v

1. https://github.com/LiveHelperChat/livehelperchat/issues/422
2. https://github.com/LiveHelperChat/livehelperchat/issues/454
3. https://github.com/LiveHelperChat/livehelperchat/issues/456

execute doc/update_db/update_87.sql for update

2.07v

1. Now you can generate embed code who represents few departments at once. https://github.com/LiveHelperChat/livehelperchat/issues/427
2. https://github.com/LiveHelperChat/livehelperchat/issues/440
3. https://github.com/LiveHelperChat/livehelperchat/issues/437
4. https://github.com/LiveHelperChat/livehelperchat/issues/433
5. https://github.com/LiveHelperChat/livehelperchat/issues/421
6. Now you can set required phone in proactive chat invitation
7. Option to set required phone length in back office.

execute doc/update_db/update_86.sql for update

2.06v

1. Option to minize widget directly to bottom corner.
2. Status widget will be hidden automatically then user opens live help widget
3. Option to change border color of status widget
4. Operator will see user local time zone. Also visitor will see messages time in their local time.
5. Because of 4 feature online visitors list was a little bit restyled.
6. Minimize and restore icons will be different now to avoid confusion
7. On minimization header will stay at the same place
8. Option to pass operator ID to chat. Usefull for integrating with third party applications. Where let say each customer has assigned operator.
9. Separated template for user message. Easier to override
10. Finnish language
11. Option to edit previous visitor/operator message by pressing Up arrow, just like skype

execute doc/update_db/update_85.sql for update

2.05v

1. Option to hide/show widget copyright small logo. 16x16
2. Option to upload your own logo for small copyright logo in widget left corner.
3. Option to track online visitors then widget is not visible because operators are offline.
4. Roles permission editing window will contain checkboxes instead of combobox.
5. Disabled ssl check for curl request, window update compatibility. Thanks to softaculous
6. Translations now also are generated for chat configuration window. User requested this.

execute doc/update_db/update_84.sql for update

2.04v

1. https://github.com/LiveHelperChat/livehelperchat/issues/412
2. Option to set default theme from back office

execute doc/update_db/update_83.sql for update

2.03v

1. Option to get browser/sound notification about new visitor in online visitors list.

execute doc/update_db/update_82.sql for update

2.02v

1. https://github.com/LiveHelperChat/livehelperchat/issues/405
2. https://github.com/LiveHelperChat/livehelperchat/issues/407

Sponsored feature
3. https://github.com/LiveHelperChat/livehelperchat/issues/408

execute doc/update_db/update_81.sql for update and create a directory 
var/storagetheme - and chmod it

2.01v

1. Restyles back office a little bit. Top menu will take less space.
2. https://github.com/LiveHelperChat/livehelperchat/issues/397
3. https://github.com/LiveHelperChat/livehelperchat/issues/367
4. https://github.com/LiveHelperChat/livehelperchat/issues/401
5. https://github.com/LiveHelperChat/livehelperchat/issues/398
6. https://github.com/LiveHelperChat/livehelperchat/issues/402

execute doc/update_db/update_80.sql for update

2.00v

Features/Changes/Bugfixes
1. https://github.com/LiveHelperChat/livehelperchat/issues/396
2. https://github.com/LiveHelperChat/livehelperchat/issues/393
3. https://github.com/LiveHelperChat/livehelperchat/issues/383
4. Fixed bug then closing tab, tab was closed but user could not reopen it. Tricky part.
5. Updated chrome extension as stated in previous article
6. New module for documents sharing.
7. Updated NodeJs extension. It was used by one of the clients who had now over 3700 chats. So it's quite stable and can be used in production.
8. Forms module now has different layout, which features angularJS support. So your forms can support angular syntax.
9. Chrome extension also was updated as mentioned in one of the previous articles.
10. Changed even them message is send. Previously it was onkeyup which coused new line if enter was pressed in the middle of the message. Now it won't.
11. Changed close/resume/minimize icons.
12. Install will enable online visitors tracking and pro active installations by default now.

execute doc/update_db/update_79.sql for update and create a directory 
var/storagedocshare - and chmod it
var/tmpfiles - and chmod it

1.99v

Features/Changes/Bugfixes

1. https://github.com/LiveHelperChat/livehelperchat/issues/381
2. https://github.com/LiveHelperChat/livehelperchat/issues/382
3. https://github.com/LiveHelperChat/livehelperchat/issues/374
4. https://github.com/LiveHelperChat/livehelperchat/issues/360
5. Then user reopens chat, chat status won't be changed unless it's closed. 

execute doc/update_db/update_78.sql for update
If you are using XMPP notifications edit xmpp notifications and in "XMPP Message about accepted chat" enter
{user_name} has accepted a chat [{chat_id}]
{messages}
{url_accept}

1.98v

Features/Changes/Bugfixes

1. https://github.com/LiveHelperChat/livehelperchat/issues/381
2. https://github.com/LiveHelperChat/livehelperchat/issues/362
3. Changed map link in chat window to be compatible with new google maps version
4. Referer page will open in a new window
5. End range for form's module will be included in combobox also
6. Pure SQL queries for performance improvement in a few places. Also implemented SQL transaction in a few places.
7. Then user naviagates to another page on site to operator will be shown user status with new page.
8. https://github.com/LiveHelperChat/livehelperchat/pull/380
9. https://github.com/LiveHelperChat/livehelperchat/pull/373
10. https://github.com/LiveHelperChat/livehelperchat/pull/379
11. https://github.com/LiveHelperChat/livehelperchat/issues/375
12. Fixed bug then same chat was transfred to department multiple times was not shown.
13. https://github.com/LiveHelperChat/livehelperchat/pull/373
14. Avoid showing widget URL instead of page url, then widget is opened.
15. Now most of generic chat's list are ajax based.
16. Fixed bug then closing tab, tab was not removed from session and upon page refresh was still open.

execute doc/update_db/update_77.sql for update

1.97v

Github changes, another new module
https://github.com/LiveHelperChat/livehelperchat/issues/363
https://github.com/LiveHelperChat/livehelperchat/issues/366

execute doc/update_db/update_76.sql for update and create a directory 
var/storageform - and chmod it

1.96v

Github changes
https://github.com/LiveHelperChat/livehelperchat/issues/345
https://github.com/LiveHelperChat/livehelperchat/issues/346

https://github.com/LiveHelperChat/livehelperchat/issues/348
Sample argument
LHCChatOptions.attr_online = new Array();
LHCChatOptions.attr_online.push({'name':'email','value':'remdex@gmail.com'});
LHCChatOptions.attr_online.push({'name':'phone','value':'370454654'});
LHCChatOptions.attr_online.push({'name':'username','value':'Username here'});

https://github.com/LiveHelperChat/livehelperchat/issues/351
New variable for FAQ template - {url_question}

execute doc/update_db/update_75.sql for update

1.95v

Mega release.

Sponsored features
1. Browser offers, see site for more information.

Other features
2. Hidden option for department, usefull if you want to have fancy department workflow and let say some department to which chat is transfered you wish were invisible to user.
3. Operator won't see others departments visitors in online visitors. Also updated javascript code generation to have this.
4. Option to close embeded chat if operator has closed it faster then user closed it.

In general these changes
https://github.com/LiveHelperChat/livehelperchat/issues/343
https://github.com/LiveHelperChat/livehelperchat/issues/342
https://github.com/LiveHelperChat/livehelperchat/issues/341

execute doc/update_db/update_74.sql for update

1.94v

Features
1. Option to force department hours to take priority over users online status. "Chat configuration" -> "Misc" -> "Ignore users online statuses and use departments online hours".
2. Option to redirect user to leave a message window manually.

execute doc/update_db/update_73.sql for update

1.93v

Features
1. Job title field for operator, this job title field will be shown instead of "Personal assistant" if it's set.
2. Option to assign pro active invitations to particular users. Just enter users id's separated by comma. Perhaps in some far feature i will add more user friendly assigment workflow, or someone will suport it :)
3. {name},{department},{country},{city} variables in subject for mail "Support request from user"
4. Disabled department widget won't be shown. Option to show widget but then in content will be written "Department is disabled"
5. Invisible mode. This allows to open chat without influencing chat status. To operator has to be assigned "Users, groups management" => "Allow user to change his visibility mode"
6. Option to change chat status. To operator has to be assigned "Chat" => "Allow user to change chat status" permission.

execute doc/update_db/update_72.sql for update

1.92v

Features
1. Option to have browser notification for new messages also not only for new chat request we have now. Can be found at "Synchronization and sound settings"
2. Messages line height adjusted
3. Submit button is disabled then user clicks it. I saw some duplicate chat request on demo. I ques users just did not waited enough after form submition.
4. Option to choose refresh interval on online users list.
5. {operator} variable in canned messages.
6. nodejs extension updated.

Bugfixes
1. FF browsers did not showed scrollbar in popup.
2. Then chat was accepted using chrome browser notification was not hidden automatically. Seems there was some internal browser API changes.
3. Some complex cases fixed then site is using https and in some places http. Read http://livehelperchat.com/how-to-configure-https-and-http-259a.html
4. Correct cache key for chatbox then memcached is used.

execute doc/update_db/update_71.sql for update

1.91v

Features
1. Option to set timeout for help tooltip
2. Option to set required e-mail for FAQ
3. E-mail notification for new FAQ item
4. Option to set secure parameter for cookies in chat module
5. Bulgarian and Romanian languages

execute doc/update_db/update_70.sql for update

1.90v

Features
1. Operator voting update upon user vote
2. Changed alert to confirm on new chat request. If user clicks ok. We open chat.
3. Datepicker for date fields.
4. Improved drag & drop logic. Now user won't be able to drag widget outside of it's viewport.
5. Option to have welcome tooltip

execute doc/update_db/update_69.sql for update

1.89v

Features
1. FAQ module supports identifiers and e-mail field. 
https://github.com/remdex/livehelperchat/issues/297
https://github.com/remdex/livehelperchat/issues/292
2. Region support for geo location
https://github.com/remdex/livehelperchat/issues/298
3. BB Code button in chatbox and live help.
4. Saint Martin flag
https://github.com/remdex/livehelperchat/issues/294


Fixes
1. In page embed live help visitors were not redirected to leave a message form.
https://github.com/remdex/livehelperchat/issues/291


execute doc/update_db/update_68.sql for update

1.88v

Features
1. Option to take screenshot in online users list.
2. Danish language

Fixes
1. In right column was incorectly calculated time since last message.

execute doc/update_db/update_67.sql for update

1.87v

Features
1. Option to take user screenshot. Used http://html2canvas.hertzen.com/
2. Option to have BCC recipient in e-mail templates https://github.com/remdex/livehelperchat/issues/282

Changes
1. Changed escape to encodeURIComponent https://github.com/remdex/livehelperchat/issues/288

execute doc/update_db/update_66.sql for update

1.86v

1. Option to set date format. Three new fields in Settings => Time zone settings section. This is available per install and not per individual user.
2. PHP-GeoIP extension support.
3. {nick} support in canned messages.

edit your settings/settings.ini.php file and under 'force_virtual_host' => false,
add
'date_format' => 'Y-m-d',
'date_hour_format' => 'H:i:s',
'date_date_hour_format' => 'Y-m-d H:i:s',


1.85v

1. Canned messages by department
2. Personal canned messages. To operators role have to be assigned "Users" => "Allow user to have personal canned messages"
3. Now then user closes a chat and operator sends a message to user, at site chat will reopen.
4. Option to hide default form fields. These fields can be prefilled but they won't be visible by user.
5. Option to specify max mind city database file.

execute doc/update_db/update_65.sql for update

1.84v

1. Option to set revote timeout, contributed by David Livingston. I just did some cleanup.
2. Window about running version. Like installation version and current version and pending database updates.

execute doc/update_db/update_64.sql for update

1.83v

1. Option to have custom timezone per application and per user. Users can change their time zone in their account.
2. Application time zone can be changed in new configuration link. If no timezone is set in user or application it depends on server.
3. File usability enchancements based on https://github.com/remdex/livehelperchat/issues/246

execute doc/update_db/update_63.sql for update
edit your settings/settings.ini.php file and under 'force_virtual_host' => false,
add 'time_zone' => '',


1.82v

1. Department has a field which help user can be redirected to leave a message form if chat is not accepted for n seconds.
2. Option to redirect user to leave a message form if chat is not accepted for n seconds. Managed in department.
3. Option to set proactive messages based on referring domain. It's enough to enter google keyword for all google domains.
4. Option to hide popup for user if user has visited invitation popup n times. Works only for proactive invitation messages.
5. User support request mail now also has template variable {prefillchat} this variable get's replaced to link to chat. 

execute doc/update_db/update_62.sql for update

1.81v

Features
1. Option to set explicit http mode either http or https. Usefull if chat is running on https and site on http. 
By default we previously just heritage site mode. Now you can explicty define how data should be transfered http or https.
2. Maximum message length for a message. Changable in chat configuration.
3. Added to long message notifications.

Bugfix
After chat was transfered to another user. Operator profile did not changed. Now it does.

execute doc/update_db/update_61.sql for update

1.80v

Features
1. Extension for Node.js enchancements. Moved typing monitoring to Node.js
2. Chatbox Memcache and Redis support. Optimized for sites with a lot of visitors. Hundred of thousands. Chatbox will work with blazing speed then memcached and Node.js is used.

Single server can handle 1K request per second. Not so bad :)

Concurrency Level:      10
Time taken for tests:   0.964 seconds
Complete requests:      1000
Failed requests:        0
Write errors:           0
Total transferred:      40933000 bytes
HTML transferred:       40485000 bytes
Requests per second:    1036.92 [#/sec] (mean)
Time per request:       9.644 [ms] (mean)
Time per request:       0.964 [ms] (mean, across all concurrent requests)
Transfer rate:          41449.31 [Kbytes/sec] received

3. Performance tweaks for chatwidget and startchat

Upgrade.
1. Adjust your settings/settings.ini.php and add the following section. Above 'site_access_options'
'memecache' =>
  		array (
  				'servers' =>
  				array (
  						0 =>
  						array (
  								'host' => '127.0.0.1',
  								'port' => '11211',
  								'weight' => 1,
  						),
  				),
  	),
'redis' => array (
  				'server' => array (
  						'host' => 'localhost',
  						'port' => 6379
  				)
),

Have fun.

1.79v

Features
1. Option to have operator remarks regarding the chat.
2. Chatbox has few other embed options, which allows to have the following use cases: 
2.1 Hide status widget and show content instantly, have content expanded or minimized instantly.
2.2 Disable user option to close a widget. Usefull if you are not showing a status widget.

execute doc/update_db/update_60.sql for update

1.78v

Features
1. Online visitors tracking across domain subdomains. You can set your domain in "Chat configuration" => "Misc" => "Set your domain to enable user tracking across different domain subdomains."
2. Mail templates now supports {country} and {city} variables.

Bugfix
1. /user/login was missing $currentUser instance after php session drop.

execute doc/update_db/update_59.sql for update

1.77v

Features
1. Option to set Long Polling for messages sync.
2. Dumped session if it's not required for anonymous users. Should give some performance boost. Let me know if you encounter any issue and I will fix it in less than 24 hours.
3. Chat tabs interface will show user options as go offline/online. Disable enable sound, this applies also to chrome extension.


If you decide to experiment with Long Polling make sure that.
1. You have enabled it in "Synchronisation and sound settings"
2. Connection to server is less than php script execution time. 29 seconds is good start.
3. Internal message sync interval is not very small. 1.5 second is good start. If you want more real time appearance. Reduce it to half second or so. 
4. You can also decrease standard "Sync for a new user message, interval in seconds" let say to half second. 0.5 or a little bit less. After one polling request another request will be executed after this value.
Good luck with your experimenting.

Bugfix
1. Removed scrollbar in popup if file upload was activated.

Update
execute doc/update_db/update_58.sql for update, I suggest review your "Synchronisation and sound settings" after update if you have tweaked them before.

1.76v

Features
1. MaxMind GEO Service, completely local solution, no need allow connection to third party services.
2. Option to have TOS checkbox. Link is changable in "Configuration" => "Copyright settings" => "Site settings"

execute doc/update_db/update_57.sql for update

1.75v

Features
1. Now you can filter online usrs by department
2. And many other small changes from last version release

execute doc/update_db/update_56.sql for update

1.74v

Features
1. Now you can setup how many times repeat sound notification.
2. Also now you can setup alert message then new chat request comes if regular notifications is not enough for you.

execute doc/update_db/update_55.sql for update

1.73v

Features
1. Chrome extension!!!
Download it from https://github.com/remdex/livehelperchat-extensions/raw/master/browsers-extensions/chrome/lhc/lhc_packed/lhc.crx
or just
https://github.com/remdex/livehelperchat-extensions/tree/master/browsers-extensions/chrome/lhc/lhc_packed
To operator should be assigned permission
"Chat" => "Allow user to user chrome extension"

Bugfixes
1. Use google maps in https if required.
2. Proper file type check.
3. Avoid conflict with third party window.Cookies variable
And some other small bugfixes..


1.72v

Features
1. Redesigned chat configuration list. It's now split into tabs and is more easier to navigate.
2. Option to choose play sound or not opon invitation box to chat is shown.

Bugfixes:
1. Sound was not played then message to user was send manually.
2. If user closed chat and resumed chat and then operator send message chat status did not changed even operator was chating. Now upon first message from operator and if chat is pending it will became active automatically.

execute doc/update_db/update_54.sql for update

1.71v

Features
1. Option to disable a department. If department is disabled it won't appear in department choosing form.

execute doc/update_db/update_53.sql for update

1.70v

1. In 1.69 was introduced drag & drop but IE users could not select any field. This issue was fixed in less than 24h. But if you are experiencing same issue I recommend to update.
2. In this version I added option to turn session cookies for form validation. Some users were reporting for getting spam. You just have to edit "chat configuration" -> "Use session captcha. LHC have to be installed on same domain or subdomain."
and set 1. Please be sure that chat is running on the same domain.

execute doc/update_db/update_52.sql for update

1.69v

//------//
Features
//------//
1. Drag & Drop support for widgets, you can drag site widgets dragging it's header.
2. Department has two separate fields one for E-Mail recipients another one for XMPP recipients. In relation to: https://github.com/remdex/livehelperchat/issues/202
3. Department also now has field for XMPP Group recipients. There can be something as somechat@conference.server.org/LiveChat
4. User also has a field xmpp username, if this field is different then user account e-mail during link clicking this field will be matched to department xmpp recipient and user will be authorised instantly.
So full flexibility to have different e-mail for system itself and different account for XMPP service providers.
5. You can now set how long chat accept link is valid. This can be found in chat configuration section.
6. Upon chat accept link click if link is invalid, user will be redirected to login page and if he is using remember me functionality he will be logged automatically and will see chat window instantly.
7. Accept link generation supports now http and https.
8. Option remove index.php from URL's

Based on
https://github.com/remdex/livehelperchat/issues/202
https://github.com/remdex/livehelperchat/issues/205
https://github.com/remdex/livehelperchat/issues/204

//------//
Changes
//------//
1. Disable posibility to choose to what department transfer chat if chosen department is self.

https://github.com/remdex/livehelperchat/issues/203

//------//
Bugfixes
1. Skype input field was missin in new window creation window.
//------//

//------//
For update
//------//

1. execute doc/update_db/update_51.sql for update

2. Add in your site settings/settings.ini.php under 
'installed' => true,

True will remove index.php from url, also you will have to use .htaccess/nginx conf provided in doc/http_conf_examples
For this to work app has to be installed on root folder, it can be either domain or subdomain.

'force_virtual_host' => false,

1.68v

Features
1. Skype call field in user attributes
2. Online operators listing will show only his department operators.
3. In order to see all operators to operators role has to be assigned "user" => "userlistonlineall" permission

Changes
1. Added check to make sure that cookie contains vid variable. (Some users were reporting that after closing invitation it's shown again instantly, personally
I just cannot reproduce it.)
2. Update to jquery 1.10.2 version.

execute doc/update_db/update_50.sql for update

1.67v

Features
1. Fontello icons for most of the icons
2. Sneek chat preview on lists. No need to accept a chat to see about what user is asking.

Bugfix.
1. After some changes up-votes and down-botes icons colors was ignored.
2. https://github.com/remdex/livehelperchat/issues/196

This is second release in the same day. Be sure that you have also executed doc/update_db/update_48.sql

execute doc/update_db/update_49.sql for update

1.66v

Features
1. Now you can configure to receive an e-mail then chat is closed.
	a. First we check does mail templates has any recipients.
	b. If not then we check for department responsible users.
	c. If not we send an e-mail to admin. 
2. I have added GTalk OAuth2 support for authorisation. It allows to authorize live helper chat to send xmpp messages using OAuth logic. So you won't have to enter your password.
If you are using two steps verification on google, you just have to generate application specific password, that's all.
3. Added more check for install script. mbstring and php_curl extension checks.

Changes
1. Fixes few typos on department edit window.

execute doc/update_db/update_48.sql for update

1.65v

Features
1. XMPP Support, you can just configure XMPP and install Xabber on your Android phone to receive new chat request. You do not have to be online all the time, you can configure your online hours in department.
2. Department online hours, you can set then chat should be online automatically by week days and hours. You can also set after how many seconds new chat callback should be executed.
3. New chat request callback option. This will allow for users implement other handlers like SMS notification etc.
5. Notification about new chats either using XMP or mail. Clicking link in mail will lead you automatically to chat.
6. Statistic page will show how many total up-votes or downvotes has received an operator.

Changes
1. Install script will show precise error.
2. Avoid language confusion in other siteaccess than site_admin.

execute doc/update_db/update_47.sql for update

1.64v

Features
1. Online visitors list will show page title insead of url. URL will be shown as link title.
2. Option to print and mail archived chat.
3. Option to add IP which should not be presented in online visitors list. Also this will avoid Proactive chat invitations to them.

Changes
1. Embed code generation can be reached only from configuration to avoid users misunderstandings.

execute doc/update_db/update_46.sql for update

1.63v

Features
1. Avatars.
2. Chat feedback by voting thumbs down and up.
2. Option to show virtual assistant profile for invitation message.

execute doc/update_db/update_45.sql for update

create directory var/userphoto make sure that php can write to it. just chmod 664 var/userphoto

1.62v

Features
1. FAQ modules URL now supports wildcard at the end.
E.g /shop/basket/*
2. Invitation widget new style. Sound on first invitation.
3. Chat API module for getting users status.

Changes from github for summary:
https://github.com/remdex/livehelperchat/issues/164
https://github.com/remdex/livehelperchat/issues/162
https://github.com/remdex/livehelperchat/issues/163

execute doc/update_db/update_44.sql for update

1.61v

1. Files upload module
1.1 You may have to grant operators few permissions for file upload to work correctly.

execute doc/update_db/update_43.sql

create directory var/storage make sure that php can write to it. just chmod 664 var/storage

1.60v

Features
1. Option fo user to change language in back office. Just for him alone. Usefull if back office is used by people who speaks different languages.
2. Chatbox now supports predefined nick and option to disable nick.

Improvements, Bugfixes
1. Few PHP calls were not compiled. So a little bit more performance gain.
2. Seems if user disabled chat sound, he could not start chat next time. Not sure still.
3. Various other small improvements.

No database update this time.

1.59v

1. Option to disable restore icon in widget. Disables popup opening in site.
2. In proactive message you can set, is mail required or not.

Bugfix.
Small grammar fix.

execute doc/update_db/update_42.sql

1.58v

1. Arhchive module for chats. Now we have unlimited number of chats support. I'm talking about tens of millions of records. If main table becames to big you can just archive the old chats.
This feature took over 20 hours to implement.
2. Indonesian language.
3. Delay for canned messages.
4. Operator is typing will be shown in a different location to avoid it appearing over message text.

execute doc/update_db/update_41.sql

1.57v

1. Option to configure default map position.
2. Departments transfer workflow will pay attention to how many pending chat's there are.
3. Firefox support for notification added.
4. Desktop client will support user typing messages. User status will be shown.

Bugfixes

execute doc/update_db/update_40.sql

1.56v

Features:
1. Automatic transfers between departments.
2. Cronjobs support

Bugfixes:
After upgrade for third parties cookies drop, identifier functionality was lost.

Visit the site for more information how to use these features.

execute doc/update_db/update_39.sql

1.55v

Features:
1. Total pageviews tracking - pageviews during all the visits
2. Visits counting.
3. Option to set, after how many hours pro active chat message should be shown again.
4. Previous users chats in chat tab window.
5. How many times proactive chat message logic was applied counter.
6. User browsing information in chat window.
7. Colors for install step 1

Bugfix:
1. Footpath was stopped tracking if user was having a chat in chatwidget.
2. Online users were tracked even if online users tracking was disabled.
3. There was a bug which coused double time for online user if checking for messages from operator was enabled. Also now we do not update database within each check for message.

execute doc/update_db/update_38.sql

1.54v

Features:
1. Option to turn off or on Resume chat functionality.
2. Reopen chat permission in back office.
3. If chat is closed operator won't be able to send messages untill it's reopened. What user reopened the chat also is logged.

Bugfixes:
1. Footprint was not detected if chat was started from proactive chat message.
2. Messages scroll was lost sometimes during tab's switching.
3. Don't blink title if textarea is active.

execute doc/update_db/update_37.sql

1.53v

Features

1. Option for user to send chat transcript to his e-mail.
2. User options as dropdown menu.
3. User status icon in tab.

execute doc/update_db/update_36.sql

1.52v

Features, sponsored release:

Auto responder.
a. Auto responder in proactive chat invitations.
b. Independent responder.

This allow you to have the following workflow.
1. Then users starts chat. He receives preconfigured message. E.g. "one moment please..."
2. If the agent doesn’t accept within a time period (e.g. 1 minute) to user is send message. "we are currenty busy with another patient right now, can you leave your name and email and we will follow up"

execute doc/update_db/update_35.sql

1.51v

Features:
1. Half spornsored kernel export module. Tutorial will be available on the site.

Changes, Bugfixes:
1. SSL support for desktop client. Just enter URL with https
2. Allow reopen chat if it does not have any messages.
3. If user is chatting do not show proactive message.
4. Just proper JSON support check. Avoids conflict with third party libraries.
5. Mark proactive message as seen during chat starting process.

execute doc/update_db/update_34.sql

1.50v

1. Multiple domains support. No third parties cookies dependency.
It's a relative big updated. Because the biggest part of front end logic was rewrite to drop the need of session.

Bug fix.
1. IE sometimes cached messages checks from operators.

1.49v

1. From now messages like "user has left chat", "user has joined chat" will be shown where you see what user is typing or user is typing message. This will avoid flood in chat itself.
2. You can configure default Operator name for proactive chats.
3. If user starts chat from proactive widget, to user won't be shown message that we are pending operator to join chat.
4. Adjusted how print icon is shown in widget.

execute doc/update_db/update_33.sql

1.48v

1. CSFR protection in sensitive locations and form posts.

1.47v

1. From chat tab you can open popup. Let say you were chatting in tab and you want to open popup. So you can do that now. There is very first icon for that.
2. Then you open let say three chats at the same time and close one. I now activate the very first tab to left. Feels very natural closing workflow.
3. Fixed bug, then closing chat in tab it removed subtabs from other chat tabs.
4. Added more clear way what embed codes system can generate
5. Switched to https support by using double slash E.g //demo.livehelperchat.com -  so I do not have to detect in what enviroment we are running.
6. You now can disable or enable invitation if there is or not online operators.
7. You can set online visitors timeout, to see only the recent visitors.
8. Check messages from operator JS call won't be counted as last visit.
9. Department chosing box will show status of department is it online or offline. First will be shown online departments.
10. Now Surname is optional field, so you can have only name filled.
11. Print option for user and admin.
12. Now you can see what user is typing before he sends message to operator.

execute doc/update_db/update_32.sql

1.46v

1. Now chats can have priority. It can be either embed variable either department attribute. Pending chats with higher priority will appear higher in the list.

execute doc/update_db/update_31.sql

1.45v

1. Spanish translation update from https://www.transifex.com/projects/p/live-helper-chat/
P.s you can find the latest translation on https://www.transifex.com/projects/p/live-helper-chat/

2. Option to override easier embed widget code.
Just override this template
design/defaulttheme/tpl/lhchat/getstatus/container.tpl.php

3. Pro active chat a little bit usability update, no label and sends message on enter click.

4. If user started chat based on proactive chat invitation, assign this message live support user.

Bugfix.
Undefined variable in start chat form.


1.44v

Bugfix.
1. Templates were loosing cache because for template cache identifier was used incorrect server variable. Performance FIX

Updates.
1. Separte template for page header in user part. This allows us to override front end without influencing back office style.
2. Updated to latest colorbox version.
3. Renamed translations files from xml to ts
4. Updated translations
4.1 Chinese
4.2 Czech, new translations
4.3 German

1.43v

Features:
1. Wait time tracking
2. Chat duration tracking
3. Separated admin chat tabs to separate templates for easier override.
4. Option to limit invitations based on pending chats number.

execute doc/update_db/update_30.sql

1.42v

Features:
1. Referer tracking. This allows to see from where initially user has came from.
2. Some other small changes

execute doc/update_db/update_29.sql

1.41v

Features:
1. Site identifier in code generation. Tt can be used to have different invite messages for different domains etc.
https://github.com/remdex/livehelperchat/issues/73
2. Option to turn of online users tracking but completely remove pro active chats invitations table scan and save a little bit of performance.

Enhancements:
1. Template cache by port.
https://github.com/remdex/livehelperchat/issues/66

2. Simpler permission access generation.
https://github.com/remdex/livehelperchat/issues/62

Bugfixes:
1. User who did not had permission to close chat was able to do that because of typo error. It's fixed now.

execute doc/update_db/update_28.sql

1.40.1v

Features:
1. Top menu remaked based on
1.1 https://github.com/raphaelsuzuki/lhc_web-defaulttheme2
1.2 https://github.com/remdex/livehelperchat/issues/36

1.40v

Features:
1. Operator to Operator chat
2. Sound on transfered chat

Bugfix:
1. Windows OS support

No database update needed this time :)

1.39.1v

Features:
1. French translation from icime.me
2. Italian translation from cliccaprezzi.it
3. Option to hide online users tab from operators.
Chat -> Allow user to view online visitors
4. Renamed "Online users" to "Online visitors"

Bugfix:
1. Removed not needed span element in online visitors section.

1.39v

Features:
1. Russian language by http://phone-home.ru
2. Polish language by http://poliman.pl
3. Footprint for user browsing
4. Google map user info with footprint
5. Reworked chat window with additional user info
5. Preview chat window listing update

execute doc/update_db/update_27.sql

1.38v

Features:
1. Pro active chat invitations https://github.com/remdex/livehelperchat/issues/49
2. Detect bots in online users to avoid them appear in online users list
3. Option to delete online user record from online users list.

Bug fixes:
1. If in FAQ widget answer is very big it hides under browser window. I have added rule for scrollbar if height is more than 200px.

execute doc/update_db/update_26.sql

1.37v

1. Online users google map https://github.com/remdex/livehelperchat/issues/45
2. Install style update
3. Statistic module, more updates is coming.
4. System assistant messages. They indicate does user left chat etc.
5. More stable detection then user closes chat window etc.
6. Option to change back office language from back office.
7. Department status for embed codes.

execute doc/update_db/update_25.sql

1.36v

1. German translations.
2. Desktop client translations.
3. Captcha protection.

1.35v

New features:
1. CSS, JS, CSS images now can be overriden in extensions.
2. Debug output window now will show used CSS and JS, including CSS images paths

P.S.
All this was done without any performance loss when the cache is enabled.

1.34v

New features:
1. Option to configure SMTP settings for mail
2. Chrome desktop notifications
3. Allow user to change his online or offline status

execute doc/update_db/update_24.sql

1.33v

New features:
1. New permissions for chat, now operators can or cannot have permission to open already opened chats. This disables reading other persons chats, except for users who have permission to do so.
This permission takes effect only if the user does not have permission to all chats.
2. Leave a message functionality

Enhancements:
1. Added support for managing permissions for extensions. Names will be listed in literal mode not in system mode.

Bugfix:
1. Avoid undefined index expand

execute doc/update_db/update_23.sql

1.32v

1. Chatbox/Shoutbox module.
2. Option to embed Chat, Shoutbox directly in the page.

execute doc/update_db/update_22.sql

1.31v

Feature release:
1. Option to pass custom arguments for chat, these arguments will be visible in the chat form
Example:
<script type="text/javascript">
var LHCChatOptions = {};
LHCChatOptions.attr = new Array();
LHCChatOptions.attr.push({'name':'Basket id','value':'<predefined value>','type':'text','size':12}); // 12 is 100% full row, 6 is 50%
LHCChatOptions.attr.push({'name':'User ID','value':'<predefined value>','type':'hidden','size':0}); // hidden is invisible field, size just zero
(function() {
var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
po.src = 'http://<some_domain>/index.php/chat/getstatus/(position)/middle_right';
var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
})();
</script>
2. Option to prefill some form attributes in javascript
<script type="text/javascript">
LHCChatOptions.attr_prefill = new Array();
LHCChatOptions.attr_prefill.push({'name':'email','value':'remdex@gmail.com'});
LHCChatOptions.attr_prefill.push({'name':'phone','value':'370888888'});
LHCChatOptions.attr_prefill.push({'name':'username','value':'Remigijus Kiminas'});
(function() {
var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
po.src = 'http://<some_domain>/index.php/chat/getstatus/(position)/middle_right';
var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
})();
</script>
3. Option to configure a chat popup window width and height, the same for a chat widget also.
4. Send mail to a user, lets say you have missed a chat, but you still want to respond to the user. With this feature you will be able to do so.
5. Dynamic widgets height and width, this will allow you to fit your content dynamically and provides even more improved usability.
6. Improved compatibility with IE8
7. Option to embed FAQ and Questionary module directly in a page

execute doc/update_db/update_21.sql

1.30v

Feature release:
1. Upgrade to Foundation 4 version
2. RTL language support

1.29v

Feature release:
1. FAQ module, show FAQ questions to your customers based on their URL.
2. Custom position from top if middle right or middle left is chosen.
3. Dutch translation, thanks to Robin Stuivenberg
4. MacOS bundle, requires QT 4.7 or 4.8 runtime library. Can anyone compile without dependencies?

execute doc/update_db/update_20.sql

1.28v

Feature release:
1. An even smarter way to check for new messages. It will avoid a query to the messages table and first check that the user last message id is lower than the chat last message id.
It's better to add one query on each message add than to execute two queries each time.
2. Override CSS created in custom theme folders.
3. Different positions for main live helper widget.
4. Small other changes, some HTML cleanup, and debug output movement from main footer.
5. Number of transferred chats will be shown also in transfer tab.

Bugfix:
1. Close dialog, Close chat, Delete stopped working after I introduced new algorithm for checking messages.

execute doc/update_db/update_19.sql

1.27v

Feature release:

Resume:
1. Questionary/Voting module for collecting users feedback.
2. Different positions for live helper main widget

execute doc/update_db/update_18_questionary.sql

1.26v

Small release compared to previous one, but it does one amazing thing. Now all messages from user or operators will be checked with the same query. Last message ID algorithm was implemented.

Resume:
1. Removed status column from messages table, it's not needed anymore.
2. The same check messages algorithm for admin and user.
3. Only one index is needed now for the messages table. It improves write operations and eliminates update in user sync call.

execute doc/update_db/update_17.sql

1.25v

Summary:
This release brings whole bunch of changes, most important is the performance ones. I have spent a lot of time optimizing every single query,
and limiting requests number to minimum.
There is few things I still would like to change, but for the moment it will be just fine. So now every single query is using an index.

Bugfixes:
1. Web interface was missing transferred chats lists.

Performance related:
1. Removed bunch of not needed queries including updates
2. Internal code cleanup.
3. General performance improvements.
4. Every single query was optimized for performance.
5. Missing MySQL indexes were added

Features:
1. Option use to choose which tabs you want to see. Click account to see the options.
2. Account page is now featured by tabs.
3. Transfer can now be done to a remote department or one of user departments user.

Stability:
1. Now if a request fails, for whatever reason, APP will continue synchronization lists.
2. Within each page refresh there was a sound that a user joined the chat, etc. It's very annoying, and now this won't be happening.

execute doc/update_db/update_16.sql

Update. Please make sure you replace ezcomponents folder also.

1.24v

Enchancements:
1. Remember me functionality
2. How many pages user have visited functionality
3. First time user visit tracking

execute doc/update_db/update_15.sql

1.23v

Enchancements:
1. Fixed few more short tags.
2. Implemented - https://github.com/remdex/livehelperchat/issues/9
3. Usability updates for online users. When the URL is very long it stretches the table, so this will be fixed.
4. Option to turn off online operators tabs completely.

execute doc/update_db/update_14.sql

1.22v

Enchancements:
1. Option to monitor online operators by other operators in dashboard.
2. Option to control sound options individually by users.

For upgrade execute
doc/update_db/update_13.sql queries.

1.21v

Enchancements:
https://github.com/remdex/livehelperchat/issues/7
https://github.com/remdex/livehelperchat/issues/6

1. Phone additional field
execute doc/update_db/update_12.sql

2. Now messages will be parsed for URL detection, smileys etc.

1.20v

1. Canned messages
execute doc/update_db/update_10.sql
http://livehelperchat.com/canned-messages-feature-93a.html
http://livehelperchat.com/canned-messages-92a.html

2. Now the operator and user can see when each is typing.
https://github.com/remdex/livehelperchat/issues/4
execute doc/update_db/update_11.sql

1.19v

1. Option to send messages to browsing user
2. Option to change operator message timeout
3. Redesigned the online users window a little bit.
4. For upgrading, please execute doc/update_db/update_9.sql
And add two variables in settings.ini.php file
'https_port' => 443,
'check_for_operator_msg' => 10,
To see where these settings have to be put-
https://github.com/remdex/livehelperchat/blob/bf02444b9142ef39aba21d1a68c8750468d736ab/lhc_web/settings/settings.ini.php

1.18v

1. GEO Detection
2. Page widget availability
3. HTML Code generation upgrades
4. For upgrading, please execute doc/update_db/update_4.sql,doc/update_db/update_5.sql,doc/update_db/update_6.sql queries.
5. Option to block users in a back office and chat window.
6. Option to see users browsing the site
7. Caching options
8. Asynchronous status loading

1.17v

1. Updated database structure a little bit to support the hide online options.
2. Now admin has an option to be hidden. Also status for a departament is now individual.
3. To enable these 2 features, please save admin users.
4. Fixed bug when editing the user password was reset.
5. Status for online will be used lh_userdep instead of users table.
6. For upgrading, please execute doc/update_db/update_3.sql query.

1.16v

This versions changes allows you to do the following things:
1. Extended core so users can override default templates and create custom themes
2. Option to write custom modules without overriding the kernel.
3. Option to override custom modules files.
4. Option to override kernel classes
5. Site access pattern, each site access can have a custom language and so on.
6. Install checks so that cache folder is writable at very beginning.
7. And a lot of other changes...

1.13v

1. Upgraded eZ Components to new version.
2. Upgraded to latest jQuery and JQuery UI

No new features was implemented.

1.12v

1. Made completely compaticble with 5.3 PHP version. Removed ereg
2. Removed lithuanian translations. It will have be now added manually.

No new features was implemented.

1.11v

1. Fixed pagination bug.
2. If empty password was changed, user account password was changed to empty one.

No new features was implemented.

1.1v

1. Implemented module for desktop client of Live helper chat
2. Fixed bug when the chat was transferred always to the first user.
3. Some code cleanup.

1.01v

1. Added a header background
2. Added a logo of Live Helper Chat

******************************
1.0v Initial release 2009-07-26